SystemOrganization addCategory: #NaughtieWiki!

HVScripting subclass: #HVNaughtieWiki
	instanceVariableNames: 'bandera page textInput screenBounds'
	classVariableNames: 'Users'
	poolDictionaries: ''
	category: 'NaughtieWiki'!

HVNaughtieWiki class
	instanceVariableNames: 'index swiki CssChoser currentPage Encript user changes ip lastSynchDate'!

!HVNaughtieWiki commentStamp: 'edc 5/28/2011 12:40' prior: 0!
HVNaughtieWiki generateDataBase
HVNaughtieWiki user
HVNaughtieWiki stop.
HVNaughtieWiki startDebugOn: 8085

HVNaughtieWiki index: 1

HVNaughtieWiki index

HVNaughtieWiki swiki

HVNaughtieWiki pageHistory

HVNaughtieWiki currentPage

HVNaughtieWiki css: CreateCssFromMe current

HVNaughtieWiki pageHistory removeLast

HVNaughtieWiki pageHistory removeAt: 658

HVNaughtieWiki lastSynchDate: '7 May 2011' asDate

HVNaughtieWiki checkIp
HVNaughtieWiki ip  '190.193.254.55'

HVNaughtieWiki syncronizeWithWiki
!

HVNaughtieWiki class
	instanceVariableNames: 'index swiki CssChoser currentPage Encript user changes ip lastSynchDate'!

!HVNaughtieWiki class methodsFor: 'accessing' stamp: 'edc 5/26/2011 09:21'!
addChanges: aChange 
	
	self changes at: aChange first put: aChange last! !

!HVNaughtieWiki class methodsFor: 'accessing' stamp: 'edc 5/26/2011 09:20'!
changes
	"HVNaughtieWiki changes"
	^ changes! !

!HVNaughtieWiki class methodsFor: 'as yet unclassified' stamp: 'edc 3/5/2011 07:40'!
checkIp
| lookIP |
lookIP := World getPublicIP.
			lookIP = self ip
				ifFalse: [ip := lookIP]! !

!HVNaughtieWiki class methodsFor: 'as yet unclassified' stamp: 'edc 5/26/2011 09:04'!
cleanup
	"HVNaughtieWiki cleanup"
	| nC |
	1
		to: swiki size
		do: [:page | 
			nC := OrderedCollection new .
			nC add: (HVNaughtieWiki swiki at: page) first.
			HVNaughtieWiki swiki at: page put: nC]! !

!HVNaughtieWiki class methodsFor: 'startup' stamp: 'edc 1/26/2010 07:14'!
createModel
^ HVNaughtieWiki new! !

!HVNaughtieWiki class methodsFor: 'as yet unclassified' stamp: 'edc 1/19/2010 04:44'!
cssChoser
^ CssChoser! !

!HVNaughtieWiki class methodsFor: 'accessing' stamp: 'edc 1/26/2010 18:14'!
cssChoser: anObject 
	"Set the value of CssChoser"
	CssChoser := anObject! !

!HVNaughtieWiki class methodsFor: 'accessing' stamp: 'edc 3/11/2011 09:22'!
currentPage
(self index > self swiki size) ifTrue: [self makeNewPages: self swiki size + 1 to: self index ].
^((self  swiki at: self  index) first).! !

!HVNaughtieWiki class methodsFor: 'as yet unclassified' stamp: 'edc 1/22/2010 07:20'!
diff: s
| aMiHTMLData xdate1 xdate2 |
aMiHTMLData := MiHTMLData new.
s reset.
aMiHTMLData title: (s upTo:$&).
	 s nextLine;next: 4.
	aMiHTMLData ip:  (s upTo:$&).
	 s nextLine;next: 4.
	xdate1 := (s upTo:$&).
	s nextLine;next: 4.
	xdate2 := (s upTo:$<).
	aMiHTMLData date: xdate1,' ', xdate2.
	^aMiHTMLData! !

!HVNaughtieWiki class methodsFor: 'as yet unclassified' stamp: 'edc 1/30/2010 09:51'!
encript
	"HVNaughtieWiki encript"
	| ordered unordered nD |
	^ Encript
		ifNil: [nD := Dictionary new.
			ordered := (String
		streamContents: [:strm | 
32 to: 126 do: [:ch| strm nextPut: (Character value: ch )]]).
			unordered := (String
		streamContents: [:strm | 
32 to: 126 do: [:ch| strm nextPut: (Character value: ch )]]) shuffled.
			ordered
				with: unordered
				do: [:o :u | nD at: o put: u].
			Encript := nD]! !

!HVNaughtieWiki class methodsFor: 'as yet unclassified' stamp: 'edc 1/30/2010 09:52'!
encriptClear
	"HVNaughtieWiki encriptClear"
	Encript := nil! !

!HVNaughtieWiki class methodsFor: 'as yet unclassified' stamp: 'edc 3/29/2011 08:35'!
haveLinks: aHtml
| start |
start := (aHtml contents splitBy: self postLinks).
	^ start size > 1! !

!HVNaughtieWiki class methodsFor: 'accessing' stamp: 'edc 1/20/2010 08:12'!
index
^index ifNil:[ index := 1]! !

!HVNaughtieWiki class methodsFor: 'accessing' stamp: 'edc 1/6/2010 18:41'!
index: aInteger
index := aInteger! !

!HVNaughtieWiki class methodsFor: 'accessing' stamp: 'edc 3/5/2011 07:30'!
ip
^ ip! !

!HVNaughtieWiki class methodsFor: 'as yet unclassified' stamp: 'edc 5/6/2011 05:59'!
lastPage
^self swiki size + 1! !

!HVNaughtieWiki class methodsFor: 'accessing' stamp: 'edc 5/6/2011 09:13'!
lastSynchDate
^lastSynchDate! !

!HVNaughtieWiki class methodsFor: 'accessing' stamp: 'edc 5/6/2011 09:14'!
lastSynchDate: aDate
	 lastSynchDate := aDate! !

!HVNaughtieWiki class methodsFor: 'working with real swiki' stamp: 'edc 3/11/2011 09:38'!
makeNewPages: aIndex to: aIndex2

 aIndex to: aIndex2 do: [:ind |
self swiki at:  ind put: OrderedCollection new.
(self swiki at:  ind ) add: MiHTMLData new]! !

!HVNaughtieWiki class methodsFor: 'as yet unclassified' stamp: 'edc 5/6/2011 07:28'!
newPageIndex: anInteger data: aMiHTMLData
	self swiki at:  anInteger put: OrderedCollection new.
	(self swiki at:  anInteger)
		add: aMiHTMLData ! !

!HVNaughtieWiki class methodsFor: 'working with real swiki' stamp: 'edc 5/25/2011 20:08'!
newPageIndex: anInteger named: aString linkFrom: aLink 
	| aMiHTMLData linkList |
	aMiHTMLData := MiHTMLData new.
	aMiHTMLData title: aString.
	aMiHTMLData color: 'default'.
	aMiHTMLData date: DateAndTime now asTimeStamp.
	linkList := '<option value="' , aLink asString , '">' , HVNaughtieWiki currentPage title.
	aMiHTMLData links: self preLinks , linkList , self postLinks.
	aMiHTMLData indexValue: anInteger.
	aMiHTMLData body: String new.
	self swiki at: anInteger put: OrderedCollection new.
	(self swiki at: anInteger)
		add: aMiHTMLData.
		HVNaughtieWikiIndex default at: aMiHTMLData title put: aMiHTMLData indexValue.
	HVNaughtieWiki changes
		add: (Array with: anInteger with: DateAndTime now asTimeStamp)! !

!HVNaughtieWiki class methodsFor: 'accessing' stamp: 'edc 1/19/2010 08:16'!
pageHistory
^(self  swiki at: self  index) .! !

!HVNaughtieWiki class methodsFor: 'as yet unclassified' stamp: 'edc 3/9/2011 08:47'!
postLinks
^'</select>&nbsp;<input type="submit" value="go there">'! !

!HVNaughtieWiki class methodsFor: 'as yet unclassified' stamp: 'edc 3/9/2011 08:46'!
preLinks
^'action="/squeak/link" method="post">&nbsp;&nbsp;<i>links to this page:</i>&nbsp;&nbsp;&nbsp;<select name="name">'! !

!HVNaughtieWiki class methodsFor: 'as yet unclassified' stamp: 'edc 1/19/2010 04:38'!
putMorph: aMorph
CssChoser := aMorph! !

!HVNaughtieWiki class methodsFor: 'as yet unclassified' stamp: 'edc  1/22/2010 08:50'!
reconvert
" HVNaughtieWiki reconvert"
| nD dir localFile s aMiHTMLData count|
nD := self swiki.
dir := FileDirectory default directoryNamed:'htmlFiles'.
2 to: nD size do:[:ind| 
	localFile := dir oldFileNamed: ind asString,'.history'.
	count := 0.
	localFile upToAll: '<td colspan=2><a href="/squeak/', ind asString,'">current</a>&nbsp;&nbsp;</td>'.
	[s := RWBinaryOrTextStream with: (localFile upToAll: 'form') withSqueakLineEndings.
	aMiHTMLData := self diff: s.
	(nD at: ind) addLast: aMiHTMLData.
	count := count + 1.
	Transcript show: count;tab.
	Transcript show: aMiHTMLData date ;cr.
	localFile nextLine;nextLine.
	localFile atEnd] whileFalse.
	]! !

!HVNaughtieWiki class methodsFor: 'cleanup' stamp: 'edc 5/26/2011 09:20'!
resetchanges
	"HVNaughtieWiki resetchanges"
	changes := Dictionary new! !

!HVNaughtieWiki class methodsFor: 'startup' stamp: 'edc 1/26/2010 07:13'!
rootView
^ HVNaughtieWikiRoot! !

!HVNaughtieWiki class methodsFor: 'accessing' stamp: 'edc 1/6/2010 05:51'!
swiki
^ swiki! !

!HVNaughtieWiki class methodsFor: 'accessing' stamp: 'edc 1/6/2010 05:51'!
swiki: aDict
swiki := aDict
! !

!HVNaughtieWiki class methodsFor: 'working with real swiki' stamp: 'edc 5/26/2011 09:36'!
synchNewPage: aHtml 
	| page homeDoc start |
	aHtml reset.
	page := self currentPage.
	page indexValue: self index.
	aHtml reset.
	start := (aHtml contents splitBy: '<img src="/schemes/squeak/')
				at: 2.
	homeDoc := (RWBinaryOrTextStream with: start) reset.
	start := (homeDoc contents splitBy: '.gif') first.
	page color: (start findTokens: '-') last.
	start := (aHtml contents splitBy: '<title>') last.
	homeDoc := (RWBinaryOrTextStream with: start) reset.
	page title: (homeDoc contents splitBy: '</title>') first.
	aHtml reset.
	start := (aHtml contents splitBy: self preLinks) last.
	aHtml contents size = start size
		ifTrue: [page links: String new]
		ifFalse: [homeDoc := (RWBinaryOrTextStream with: start) reset.
			start := (homeDoc contents splitBy: self postLinks) first.
			page links: self preLinks , start , self postLinks.
			aHtml reset].
	start := (aHtml contents splitBy: '</div>') last.
	page body: start.
	aHtml reset.
	start := (aHtml contents splitBy: 'Last updated at') last.
	homeDoc := (RWBinaryOrTextStream with: start) reset.
	start := (homeDoc contents splitBy: '</div>') first.
	page date: (start splitBy: 'on ') last asDate.
	page date  < HVNaughtieWiki lastSynchDate
		ifTrue: [self halt].
	(self swiki at: self index)
		add: page! !

!HVNaughtieWiki class methodsFor: 'working with real swiki' stamp: 'edc 3/29/2011 08:44'!
synchPageNumber: ainteger 
	"HVNaughtieWiki synchPageNumber: 1"
	| page homeDoc start aHtml |
	HVNaughtieWiki index: ainteger.
	aHtml := HTTPSocket httpGet: 'http://wiki.squeak.org/squeak/' , ainteger asString.
	aHtml reset.
	(self haveLinks: aHtml)
		ifTrue: [start := (aHtml contents splitBy: self preLinks) last.
			homeDoc := (RWBinaryOrTextStream with: start) reset.
			start := (homeDoc contents splitBy: self postLinks) first.
			page := HVNaughtieWiki currentPage.
			page links: self preLinks , start , self postLinks]
		ifFalse: [page := HVNaughtieWiki currentPage.
			page links: nil].
	aHtml reset.
	aHtml upToAll: 'Last updated at'.
	start := aHtml upToAll: '</div>'.
	page date: (start splitBy: 'on ') last asDate.
	page date asYear < 2010 asYear
		ifTrue: [self halt].
	start := aHtml upToAll: '</body>'.
	page body: start.
	(self swiki at: self index)
		add: page! !

!HVNaughtieWiki class methodsFor: 'as yet unclassified' stamp: 'edc 6/2/2011 09:23'!
syncronizeChanges: aChanges 
	aChanges
		keysAndValuesDo: [:anInteger :aMiHTMLData | self swiki at: anInteger
				 ifPresent:[self swiki at: anInteger add: aMiHTMLData]]! !

!HVNaughtieWiki class methodsFor: 'working with real swiki' stamp: 'edc 5/11/2011 10:05'!
syncronizeWithWiki
	"HVNaughtieWiki syncronizeWithWiki"
	| homeDoc regex start path link remFile pageIndex |
	Transcript clear.
	path := 'http://wiki.squeak.org/'.
	homeDoc := HTTPSocket httpGet: path , 'squeak/completeChanges'.
	homeDoc reset.
	start := (homeDoc contents splitBy: '<h2>Complete Changes to Squeak Swiki</h2>') last.
	homeDoc := (RWBinaryOrTextStream with: start) reset.
	regex := RxMatcher forString: '<a href=[^<]+>'.
	regex
		matchesOnStream: homeDoc
		do: [:ea | 
			link := (ea findTokens: '"')
						at: 2.
			remFile := HTTPSocket httpGet: path , link.
			pageIndex := (ea findTokens: '/') last asInteger.
			HVNaughtieWiki index: pageIndex.
			self synchNewPage: remFile.
			Transcript show: HVNaughtieWiki currentPage title;
				 cr.
			HVNaughtieWiki
				addChanges: (Array with: HVNaughtieWiki index with: HVNaughtieWiki currentPage date asTimeStamp)].
	HVNaughtieWiki lastSynchDate: Date today.
	^ self halt! !

!HVNaughtieWiki class methodsFor: 'accessing' stamp: 'edc 4/3/2010 08:15'!
user
^user! !

!HVNaughtieWiki class methodsFor: 'accessing' stamp: 'edc 4/3/2010 08:16'!
user: aUser
	 user := aUser! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 8/19/2010 10:06'!
accion: aString 
	| s aMiHTMLData builder xhtm mode |
	s := aString findTokens: '.'.
	self class index: (s at: 1) asInteger.
	mode := s at: 2.
	bandera := (s at: 2) asSymbol.
	builder := self builder.
	aMiHTMLData := self class currentPage.
	xhtm := self pageFirstWith: aMiHTMLData.
	mode caseOf: {
		['save'] -> [^ self save].
		['edit'] -> 
			[
			aMiHTMLData isProtected
				ifTrue: [s := self htmPass]
				ifFalse: [s := self htmNoPass].
			s := s , self aidaScript].
		['search'] -> [^ self search].
		['recent'] -> [^ self recent].
		['version'] -> [^ self version].
		['history'] -> [^ self history].
		['upload'] -> [^ self upload]}
		 otherwise: [self halt].
	^ xhtm := xhtm , s! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 8/16/2010 09:14'!
aidaScript
	| t |
	t := self trucho.
	^ t , '<!!-- TinyMCE -->
<script type="text/javascript" src="/tinymce/jscripts/tiny_mce/tiny_mce.js"></script>
<script type="text/javascript">
	tinyMCE.init({
		// General options
		mode : "textareas",
		theme : "advanced",
		plugins : "safari,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,inlinepopups",

		// Theme options
		theme_advanced_buttons1 : "save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect,fontselect,fontsizeselect",
		theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,insertdate,inserttime,preview,|,forecolor,backcolor",
		theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,iespell,media,advhr,|,print,|,ltr,rtl,|,fullscreen",
		theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,template,pagebreak",
		theme_advanced_toolbar_location : "top",
		theme_advanced_toolbar_align : "left",
		theme_advanced_statusbar_location : "bottom",
		theme_advanced_resizing : true,

		// Example word content CSS (should be your site CSS) this one removes paragraph margins
		content_css : "css/word.css",

		// Drop lists for link/image/media/template dialogs
		template_external_list_url : "lists/template_list.js",
		external_link_list_url : "lists/link_list.js",
		external_image_list_url : "lists/image_list.js",
		media_external_list_url : "lists/media_list.js",

		// Replace values for the template plugin
		template_replace_values : {
			username : "Some User",
			staffid : "991234"
		}
	});
</script>
<!!-- /TinyMCE -->

</head>
<body>

<form method="post" action="http://tinymce.moxiecode.com/dump.php?example=true">



	<!!-- Gets replaced with TinyMCE, remember HTML in a textarea should be encoded -->
	<textarea id="body" name="body" rows="30" cols="40" style="width: 80%">' , self class currentPage body , '
	</textarea>

	<br />
	<input type="submit" name="save" value="Submit" />
	<input type="reset" name="reset" value="Reset" />
</form>
'"60"! !

!HVNaughtieWiki methodsFor: 'accessing' stamp: 'edc 3/19/2011 07:30'!
arreglarColor
	| homeDoc start path |
	path := 'http://wiki.squeak.org/squeak/' , self class index asString.
	homeDoc := HTTPSocket httpGet: path .
	homeDoc reset.
	start := (homeDoc contents splitBy: '<img src="/schemes/squeak/')
				at: 2.
	homeDoc := (RWBinaryOrTextStream with: start) reset.
	start := (homeDoc contents splitBy: '.gif') first.
	self class currentPage color: (start findTokens: '-') last! !

!HVNaughtieWiki methodsFor: 'accessing' stamp: 'edc 3/19/2011 07:22'!
arreglarColor: aHtml 
	|   homeDoc start |
	aHtml reset.
	page := self currentPage.
	page indexValue: self index.
	aHtml reset.
	start := (aHtml contents splitBy: '<img src="/schemes/squeak/')
				at: 2.
	homeDoc := (RWBinaryOrTextStream with: start) reset.
	start := (homeDoc contents splitBy: 'gif') first.
	page color: (start findTokens: '-') last.! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/1/2010 09:25'!
bandera
	"Answer the value of bandera"

	^ bandera! !

!HVNaughtieWiki methodsFor: 'accessing' stamp: 'edc 1/1/2010 09:25'!
bandera: anObject
	"Set the value of bandera"

	bandera := anObject! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/26/2010 07:19'!
busca
^'<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Musica para Carrie</title>
<script type="text/javascript" src="/schemes/squeak/scripts.js" charset="ISO-8859-1"></script>
<link rel=stylesheet href="/schemes/squeak/style.css" type="text/css">
</head>
<body bgcolor="#ffffff" text="#000000" link="#0000ee" alink="#ff0000" vlink="#551a8b">

<h2>Buscar Autor , si es que existe </h2>
<form action="/buscautor">
<table border=0 cellpadding=0 cellspacing=0>
<tr><td colspan=2><input type="text" size=31 name="buscar">

<input type="submit" value="buscar"></td></tr>
</table>
</form>
'! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/27/2010 09:10'!
buscautor
	| url pos1 |
	url := self urlStream url printString.
	pos1 := (url indexOf: $=)
				+ 1.
	^ self
		searchMusic: (url copyFrom: pos1 to: url size)! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/31/2010 07:51'!
captcha
	| b |
	b := self builder.
	b html: '<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>HVcaptchca para Carrie</title>
<script type="text/javascript" src="/schemes/squeak/scripts.js" charset="ISO-8859-1"></script>
<link rel=stylesheet href="/schemes/squeak/style.css" type="text/css">
</head>
<body bgcolor="#ffffff" text="#000000" link="#0000ee" alink="#ff0000" vlink="#551a8b">

<h2>Enter Captchca </h2>
<form action="/enterHVcaptchca">
<table border=0 cellpadding=0 cellspacing=0>
<tr><td colspan=2><input type="text" size=31 name="enter">

<input type="submit" value="enterHVcaptchca"></td></tr>
</table>
</form>
'.
	b html: '<img src="/gCaptchca/">
	'.
	^ b! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 6/2/2010 08:08'!
checkVisitorCaptchca
	| visitors remoteIp historia userCaptchca |
	
	visitors := HVNaughtieUsers visitors.
	remoteIp := request remoteAddress asIpString.
	historia := visitors
				at: remoteIp
				ifAbsentPut: [OrderedCollection new].
	historia
		ifEmpty: [^ false].
	userCaptchca := historia last.
	^ userCaptchca last = HVcaptchca last! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 2/3/2010 07:51'!
click
	| punto m aPoint selMorph newCss aMiHTMLData |
	punto := request fields keyAtValue: ''.
	punto := punto findTokens: ','.
	aPoint := Point x: punto first y: punto last.
	m := self class cssChoser.
	selMorph := m morphsAt: m topLeft + aPoint.
	selMorph := selMorph
				detect: [:ea | ea class == Morph].
	newCss := CreateCssFromMe create: selMorph.
	aMiHTMLData := self class currentPage.
	aMiHTMLData css: newCss first.
	^ self save: aMiHTMLData! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 2/6/2010 11:03'!
click: aPoint button: aButton 
	| evt |
	evt := Sensor createMouseEvent.
	aButton = '5'
		ifTrue: [Clipboard clipboardText: textInput.
			World activeHand keyboardFocus editView paste]
		ifFalse: [aButton = '6'
				ifTrue: [evt at: 5 put: 0.
					evt at: 3 put: aPoint x + self screenBounds origin x.
					evt at: 4 put: aPoint y + self screenBounds origin y.
					Sensor processEvent: evt]
				ifFalse: [evt at: 3 put: aPoint x + self screenBounds origin x.
					evt at: 4 put: aPoint y + self screenBounds origin y.
					evt at: 5 put: aButton asNumber.
					Sensor processEvent: evt.
					aButton = '3'
						ifFalse: [evt at: 5 put: 0.
							Sensor processEvent: evt]]].
	(Delay forMilliseconds: 10) wait! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 2/6/2010 11:02'!
clickWeb
	| fields aPoint aButton |
	fields := request fields.
	aButton := fields at: 'button'.
	aPoint := Point x: (fields at: 'point.x') asInteger y: (fields at: 'point.y') asInteger.
	self click: aPoint button: aButton.
	^ self remote! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/28/2010 07:06'!
css
	| thisCss |
	
	thisCss := self class currentPage css.
	
	thisCss
		ifNil: [^ self class css]
		ifNotNil: [^ thisCss := CreateCssFromMe misCss at: thisCss]! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 4/17/2010 11:15'!
debug
self halt.! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 5/28/2011 05:01'!
default
	self bandera: #view.
	^ self page: 3034 encript: false! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/29/2010 11:25'!
dispatchOn: method 
	"Dispatch to correct method:
	- If method is empty we call #default
	- If the selector is allowed to be executed then we just call it
	- If method is prefixed with 'src' and viewing the source is allowed,
	then we return a HTML page with the source for that method."
	| m who |
	who := self request
				headerAt: 'from'
				ifAbsent: ['yo'].
	who = 'googlebot(at)googlebot.com'
		ifTrue: [^ self serverError: 'Forbiden'].
	
	method isEmptyOrNil
		ifTrue: [^ self default].
	m := method asSymbol.
	(self allowedSelector: m)
		ifTrue: [^ self perform: m].
	"Is it a request for the source?"
	(m beginsWith: 'src')
		ifTrue: [m := (m asString last: m size - 3) asSymbol.
			(self allowedSrcSelector: m)
				ifTrue: [^ self showSourceFor: m]
				ifFalse: [^ self serverError: 'Not allowed to view source']]
		ifFalse: [^ self serverError: 'Specified URL: #' , method , ' not allowed']! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 2/2/2010 07:38'!
doEncript: aString 
	| encript s |
	encript := self class encript.
	s := String new.
	aString
		do: [:ch | s := s , (encript
							at: ch
							ifAbsent: [ch]) asString].
	s := s , s , '</body>
</html>'.
	^ s! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 6/2/2010 06:08'!
enterHVcaptchca
	| userCaptchca visitors remoteIp historia |
	userCaptchca := self request
				propertyAt: #queryString
				ifAbsent: [].
	userCaptchca := (userCaptchca findTokens: '=') last.
	visitors := HVNaughtieUsers visitors.
	remoteIp := request remoteAddress asIpString.
	historia := (visitors at: remoteIp) last.
	userCaptchca = historia last
		ifTrue: [^ self page: self class index encript: false].
	^ self captcha! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 6/3/2010 09:05'!
file
	"Download a file."
	"First we pick out the filename and turn the characters escaped by the
	browser back."
	| fileName stream dir subDirName subDir|

	fileName := self urlStream pathElements last .
	"If the filename is empty we use the inherited method #serverError to
	return a simple error page.
	Oterwise we open the file and if it exists we finally return the stream
	which will be converted
	into a HTTP response just before being returned to Comanche."
	fileName isEmpty
		ifTrue: [^ self serverError: 'No filename specified in URL.']
		ifFalse: [[dir := FileDirectory default directoryNamed: 'uploads'.
		subDirName := self urlStream pathElements at: 3.
		subDir := dir directoryNamed: subDirName.
				
				stream := subDir oldFileNamed: fileName]
				on: FileDoesNotExistException
				do: [^ self serverError: 'No file found with name: ' , fileName]].
	^ stream! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/18/2010 06:59'!
filesTable: b 
	| checkBoxes dir fn size deleteButton |
	checkBoxes := Dictionary new.
	1
		to: 2
		do: [:part | 
			b hr.
			b
				columnsHeads: #('Choose' 'Filename' 'Size' )
				do: ["Create a dictionary to hold the checkbox widgets for
					each file
					using the filename as the key."
					part = 1
						ifTrue: [b html: '<h3>Attachments to this Page</h3>'.
							dir := FileDirectory default directoryNamed: 'uploads/' , self class index asString].
					part = 2
						ifTrue: [b html: '<h3>Attachments to this Swiki</h3>'.
							dir := FileDirectory default directoryNamed: 'uploads/'].
					dir entries
						do: [:e | "For all entries in the directory we pick out
							filename and size."
							e isDirectory
								ifFalse: [fn := e first.
									size := e last.
									"Add a checkbox to the page and take the
									resulting widget and stuff it into the
									dictionary using the
									filename as key."
									checkBoxes at: fn put: b inputCheckbox.
									"#colTab moves to the next column in the
									table, there we
									add a link for each file that will
									point to the #file
									method in this class
									with the filename added at the end of
									the url. #colTab
									also automatically moves to the next
									row in the table."
									b colTab; linkLocal: 'file/' , fn text: fn; colTab; html: size printString; colTab]]]].
	"Add a delete button with label."
	deleteButton := b submit: 'Delete selected files'.
	"End the form, add a horisontal ruler, a link to the source of
	this method and end the web page."
	"Ok, if this was a POST of the second form the deleteButton will
	know it
	and the code will be run. We loop through all entries in the
	dictionary and depending on the #value of each checkbox we
	delete the file."
	deleteButton
		ifPressed: [checkBoxes
				keysAndValuesDo: [:name :box | 
					box value
						ifTrue: [dir deleteFileNamed: name].
					self reload]].
	^ b! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 6/2/2010 08:06'!
gCaptchca
	| r visitors remoteIp historia |
	
	r := HVcaptchca oneDifferentIn5.
	
	visitors := HVNaughtieUsers visitors.
	remoteIp := request remoteAddress asIpString.
	historia := visitors
				at: remoteIp
				ifAbsent: [visitors at: remoteIp put: OrderedCollection new].
	historia
		add: (Array
				with: (String
						streamContents: [:strm | (TimeStamp fromSeconds: request timestamp)
								printCLFFormatOn: strm])
				with: r last).
	^ r first! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 3/3/2011 11:34'!
help
	| f dir filePath|
	dir := FileDirectory default.
	filePath := dir pathName.
 filePath := filePath , FileDirectory slash , '/schemes/squeak/help.html'.
	f := FileStream oldFileNamed: filePath.
	f converter: Latin1TextConverter new.
	^ f contents! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc  1/22/2010 10:46'!
history
|xhtm down |
(HVNaughtieWiki pageHistory size) > 100 ifTrue:[down := ((HVNaughtieWiki pageHistory size)-100)]
ifFalse:[down := 1].
xhtm := '<table border=0 cellpadding=3 cellspacing=0>
<tr>
<td colspan=2><b>Version</b>&nbsp;&nbsp;</td>
<td><b>Name</b>&nbsp;&nbsp;</td>
<td><b>User</b>&nbsp;&nbsp;</td>

<td><b>Date</b>&nbsp;&nbsp;</td>
<td><b>Time</b>&nbsp;&nbsp;</td>
</tr>
'.
(HVNaughtieWiki pageHistory size) to: down by:-1  do: [:i |
xhtm := xhtm , '<tr>
',(self htmHistory: i ).
xhtm := xhtm , (self htmVersion: i) , '
</tr>
'].
^xhtm! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/12/2010 06:08'!
htmDiv: aMiHTMLData
	^ 


'<div style="font-weight: bold; font-size: x-large; padding-top: 1ex">',aMiHTMLData title,'</div>
<div style="font-weight: normal; font-size: x-small; padding-bottom: 2ex">Last updated at ', aMiHTMLData date printString,'</div>'
! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 5/29/2011 07:32'!
htmForm1
	self bandera = #edit
		ifTrue: [^ '</form></td></tr>
<tr><td width="100%" valign=bottom><a href="/squeak/' , self class index asString , '" title="View this Page" onMouseOver="rollOver(''''view'''', false)" onMouseOut="rollOver(''''view'''', false)"><img src="/schemes/squeak/view.gif" id="view" name="view" border=0 width=67 height=28 alt="View this Page">' , self jEditTrue]
	
		ifFalse: [^ '</form></td></tr>
<tr><td width="100%" valign=bottom>' , self jCaptchca , self jselCss , self jIndex , self jEditFalse]! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 5/26/2011 20:08'!
htmForm2
	self bandera = #edit
		ifTrue: [^ '</a><a href="/squeak/' , self class index asString , '.upload" title="Uploads to this Page"  onMouseOver="rollOver(''''  upload'''', true)" onMouseOut="rollOver(''''upload'''', false)"><img src="/schemes/squeak/upload.gif" id="upload" name="upload" border=0 width=81 height=28 alt="Uploads to this Page"></a><a href="/squeak/' , self class index asString , '.history" title="History of this Page" onMouseOver="rollOver(''''history'''', true)" onMouseOut="rollOver(''''history'''', false)"><img src="/schemes/squeak/history.gif" id="history" name="history" border=0 width=79 height=28 alt="History of this Page"></a><a href="/squeak" title="Top of the Swiki" onMouseOver="rollOver(''''top'''', true)" onMouseOut="rollOver(''''top'''', false)"><img src="/schemes/squeak/top.gif" id="top" name="top" border=0 width=55 height=28 alt="Top of the Swiki"></a><a href="/squeak/recent" title="Recent Changes" onMouseOver="rollOver(''''recent'''', true)" onMouseOut="rollOver(''''recent'''', false)"><img src="/schemes/squeak/recent.gif" id="recent" name="recent" border=0 width=85 height=28 alt="Recent Changes"></a><a href="/squeak/search" title="Search the Swiki" onMouseOver="rollOver(''''search'''', true)" onMouseOut="rollOver(''''search'''', false)"><img src="/schemes/squeak/search.gif" id="search" name="search" border=0 width=76 height=28 alt="Search the Swiki"></a><a href="/squeak/help" title="Help Guide" onMouseOver="rollOver(''''help'''', true)" onMouseOut="rollOver(''''help'''', false)"><img src="/schemes/squeak/help.gif" id="help" name="help" border=0 width=63 height=28 alt="Help Guide"></a></td></tr>
<tr><td colspan=2 background="/schemes/squeak/bottom.gif"><img width=1 height=6 src="/schemes/squeak/bottom.gif"></td></tr></table><form action="/squeak/' , self class index asString , '.save" method=post>']
		ifFalse: [^'</a><a href="/squeak/' , self class index asString , '.history" title="History of this Page" onMouseOver="rollOver(''''history'''', true)" onMouseOut="rollOver(''''history'''', false)"><img src="/schemes/squeak/history.gif" id="history" name="history" border=0 width=79 height=28 alt="History of this Page"></a><a href="/squeak" title="Top of the Swiki" onMouseOver="rollOver(''''top'''', true)" onMouseOut="rollOver(''''top'''', false)"><img src="/schemes/squeak/top.gif" id="top" name="top" border=0 width=55 height=28 alt="Top of the Swiki"></a><a href="/squeak/recent" title="Recent Changes" onMouseOver="rollOver(''''recent'''', true)" onMouseOut="rollOver(''''recent'''', false)"><img src="/schemes/squeak/recent.gif" id="recent" name="recent" border=0 width=85 height=28 alt="Recent Changes"></a><a href="/squeak/search" title="Search the Swiki" onMouseOver="rollOver(''''search'''', true)" onMouseOut="rollOver(''''search'''', false)"><img src="/schemes/squeak/search.gif" id="search" name="search" border=0 width=76 height=28 alt="Search the Swiki"></a><a href="/squeak/help" title="Help Guide" onMouseOver="rollOver(''''help'''', true)" onMouseOut="rollOver(''''help'''', false)"><img src="/schemes/squeak/help.gif" id="help" name="help" border=0 width=63 height=28 alt="Help Guide"></a></td></tr>
<tr><td colspan=2 background="/schemes/squeak/bottom.gif"><img width=1 height=6 src="/schemes/squeak/bottom.gif"></td></tr></table><form action="/squeak/' , self class index asString , '.save" method=post>']! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/19/2010 10:24'!
htmHistory: anInteger
^'<td><form action="/squeak/' , self class index asString , '.version"><input type="hidden" name="id" value="',anInteger asString  ,'"><input type="submit" value="',anInteger asString  ,'"></form></td>
<td><form action="/squeak/' , self class index asString , '.diff"><input type="hidden" name="id" value="',anInteger asString  ,'"><input type="submit" value="+/-"></form></td>'
! !

!HVNaughtieWiki methodsFor: 'actions' stamp: 'edc 8/16/2010 10:25'!
htmNoPass
	^ '
<input type="radio" name="lock" value="unlocked" onClick="this.form.password.disabled=true" checked>&nbsp;&nbsp;unlocked (<em>default</em>)&nbsp;&nbsp;&nbsp;<br>
<input type="radio" name="lock" value="locked" onClick="this.form.password.disabled=false">&nbsp;&nbsp;lock page by password&nbsp;&nbsp;&nbsp;<br>
<input type="radio" name="lock" value="open" onClick="this.form.password.disabled=false">&nbsp;&nbsp;prevent page from being locked&nbsp;&nbsp;&nbsp;<br>

<input type="text" size=10 name="password" disabled>&nbsp;&nbsp;enter new password<br>
'! !

!HVNaughtieWiki methodsFor: 'actions' stamp: 'edc 8/13/2010 11:14'!
htmPass
	 ^ '<input type="hidden" value="' , HVNaughtieWiki currentPage pass , '" name="edittime">
<p>This page has been locked by password. You can only edit it with that password.</p>
<input type="password" size=10 name="password">&nbsp;&nbsp;enter the password<br>

<input type="radio" name="lock" value="unlocked">&nbsp;&nbsp;unlock this page<br>
<input type="radio" name="lock" value="locked" checked>&nbsp;&nbsp;keep this page locked<br>
<input type="radio" name="lock" value="open">&nbsp;&nbsp;unlock this page and prevent it from being locked<br>
<hr size=1 noshade>'.
! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/28/2010 07:03'!
htmScript
	^ '
<script type="text/javascript" src="/schemes/squeak/scripts.js" charset="ISO-8859-1"></script>
<link rel=stylesheet href="/schemes/squeak/style.css" type="text/css">
</head>
<script type="text/javascript">
<!!--
initRollOver(new Array("view", "edit", "editlock", "upload", "history", "top", "recent", "search", "help"), "/schemes/squeak/");
//-->
</script>
'! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/17/2010 08:58'!
htmSearch
	^'<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Search Squeak Swiki</title>
<script type="text/javascript" src="/schemes/squeak/scripts.js" charset="ISO-8859-1"></script>
<link rel=stylesheet href="/schemes/squeak/style.css" type="text/css">
</head>
<body bgcolor="#ffffff" text="#000000" link="#0000ee" alink="#ff0000" vlink="#551a8b">
<script type="text/javascript">
<!!--
initRollOver(new Array("view", "edit", "editlock", "upload", "history", "top", "recent", "search", "help"), "/schemes/squeak/");
//-->
</script>
<table border=0 cellspacing=0 cellpadding=0 width="100%" bgcolor="#ccccff">
<tr><td colspan=2 background="/schemes/squeak/topborder.gif"><img width=1 height=6 src="/schemes/squeak/topborder.gif"></td></tr>
<tr><td width=100 rowspan=2><a href="http://www.squeak.org/"><img src="/schemes/squeak/squeak-default.gif" border=0 width=100 height=60 alt="Squeak"></a></td><td width="100%" valign=middle><table border=0 cellpadding=0 cellspacing=0><tr>
<td align=left valign=top>&nbsp;&nbsp;<a href="/squeak/2">QotD</a>&nbsp;&nbsp;&nbsp;</td>

<td align=left valign=top>If it was not like this, then it was something equally interesting ;-)<br>
                      &#8211; Jecel<br>
</td>
</tr></table></td></tr>
<tr><td width="100%" valign=bottom><img src="/schemes/squeak/viewbw.gif" border=0 width=67 height=28 alt="View this Page"><img src="/schemes/squeak/editbw.gif" border=0 width=61 height=28 alt="Edit this Page"><img src="/schemes/squeak/uploadbw.gif" border=0 width=81 height=28 alt="Uploads to this Page"><img src="/schemes/squeak/historybw.gif" border=0 width=79 height=28 alt="History of this Page"><a href="/squeak" title="Top of the Swiki" onMouseOver="rollOver(''''top'''', true)" onMouseOut="rollOver(''''top'''', false)"><img src="/schemes/squeak/top.gif" id="top" name="top" border=0 width=55 height=28 alt="Top of the Swiki"></a><a href="/squeak/recent" title="Recent Changes" onMouseOver="rollOver(''''recent'''', true)" onMouseOut="rollOver(''''recent'''', false)"><img src="/schemes/squeak/recent.gif" id="recent" name="recent" border=0 width=85 height=28 alt="Recent Changes"></a><img src="/schemes/squeak/searchie.gif" border=0 width=76 height=28 alt="Search the Swiki"><a href="/squeak/help" title="Help Guide" onMouseOver="rollOver(''''help'''', true)" onMouseOut="rollOver(''''help'''', false)"><img src="/schemes/squeak/help.gif" id="help" name="help" border=0 width=63 height=28 alt="Help Guide"></a></td></tr>
<tr><td colspan=2 background="/schemes/squeak/bottom.gif"><img width=1 height=6 src="/schemes/squeak/bottom.gif"></td></tr>
</table>
<h2>Search Squeak Swiki</h2>
<form action="/squeak/search">
<table border=0 cellpadding=0 cellspacing=0>
<tr><td colspan=2><input type="text" size=31 name="search">
<input type="submit" value="search"></td></tr>

<tr><td><input type="radio" name="casesensitive" value="true">&nbsp;&nbsp;case sensitive&nbsp;&nbsp;&nbsp;<br>
<input type="radio" name="casesensitive" value="false" checked>&nbsp;&nbsp;case insensitive&nbsp;&nbsp;&nbsp;</td>
<td><input type="radio" name="and" value="true" checked>&nbsp;&nbsp;all words and phrases (eg: "I am a phrase") match<br>
<input type="radio" name="and" value="false">&nbsp;&nbsp;at least one word or phrase matches</td></tr>
</table>
</form>'
! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/29/2010 09:41'!
htmStart
	^ '<!!!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<META NAME="ROBOTS" CONTENT="NOINDEX, NOFOLLOW">
<html>
<head>
<title>'! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/28/2010 07:37'!
htmTable: aColor 
	| swikiColor |
	aColor caseOf: {
		['default'] -> [swikiColor := '"#ccccff"'].
		['yellow'] -> [swikiColor := '"#ffffcc"'].
		['green'] -> [swikiColor := '"#ccff99"'].
		['pink'] -> [swikiColor := '"#ffccff"'].
		['blue'] -> [swikiColor := '"#99ccff"'].
		['orange'] -> [swikiColor := '"#ffcc66"']}.
	^ '
<table border=0 cellspacing=0 cellpadding=0 width="100%" bgcolor=' , swikiColor , '>
<tr><td colspan=2 background="/schemes/squeak/topborder.gif"><img width=1 height=6 src="/schemes/squeak/topborder.gif"></td></tr>
<tr><td width=100 rowspan=2><a href="http://www.squeak.org/"><img src="/schemes/squeak/squeak-' , aColor , '.gif" border=0 width=100 height=60 alt="Squeak"></a></td><td width="100%" valign=middle>
<form '! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/16/2010 09:12'!
htmUploads: docTitle 
	^ ' <h2>Uploads to this Page (' , docTitle , ')</h2>
<form action="/squeak/' , self class index asString , '.attach" method="post" enctype="multipart/form-data">
<table border=0 cellpadding=0 cellspacing=0>
<tr><td colspan=2><input type="file" name="filestuff">&nbsp;&nbsp;<input type="submit" value="upload"></td></tr>
<tr><td><input type="radio" name="specific" value="true" checked>&nbsp;&nbsp;upload to the page&nbsp;&nbsp;&nbsp;<br>
<input type="radio" name="specific" value="false">&nbsp;&nbsp;upload to the Swiki&nbsp;&nbsp;&nbsp;</td>
<td><input type="radio" name="reference" value="true" checked>&nbsp;&nbsp;add a reference to the upload at the end of the page<br>

<input type="radio" name="reference" value="false">&nbsp;&nbsp;do not add a reference</td></tr>
</table>
</form>
<p>To reference your upload, insert <tt>&lt;?<a class="internal" href="/squeak/help#plugIn">file</a> src="myUploadFileName"?&gt;</tt> into the page text. To in-line images (GIF, JPEG, or PNG), use <tt>&lt;?<a class="internal" href="/squeak/help#plugIn">image</a> src="myUploadFileName"?&gt;</tt> instead. 1183 Mb used of 5000 Mb; 3816 Mb free.</p>'! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/20/2010 09:37'!
htmVersion
 | cp |
cp := self class currentPage.
^ '<td>',  cp title,'</td>
<td>',cp ip,'&nbsp;&nbsp;</td>
<td>', cp date asTimeStamp printHttpFormat,'&nbsp;&nbsp;</td>'


! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc  1/22/2010 10:47'!
htmVersion: i
 | MiHTMLData |
MiHTMLData := self class pageHistory reverse at: i .
^ '<td>',  MiHTMLData title,'</td>
<td>',MiHTMLData ip,'&nbsp;&nbsp;</td>
<td>', MiHTMLData date asTimeStamp printHttpFormat,'&nbsp;&nbsp;</td>'


! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 2/14/2011 10:13'!
index
	| query builder v s l|
	builder := self builder.
	builder html: '<h1>Website A-Z Index</h1>
		<p><a href="#A">A</a> <a href="#B">B</a> <a href="#C">C</a> <a href="#D">D</a> <a href="#E">E</a> <a href="#F">F</a> <a href="#G">G</a> <a href="#H">H</a> <a href="#I">I</a> <a href="#J">J</a> <a href="#K">K</a> <a href="#L">L</a> <a href="#M">M</a> <a href="#N">N</a> <a href="#O">O</a> <a href="#P">P</a> <a href="#Q">Q</a> <a href="#R">R</a> <a href="#S">S</a> <a href="#T">T</a> <a href="#U">U</a> <a href="#V">V</a> <a href="#W">W</a> <a href="#X">X</a> <a href="#Y">Y</a> <a href="#Z">Z</a></p
'.
	($A to: $Z)
		collect: [:aLetter | 
			s := ''.
			#('<a id="' '" name="' '"></a>' )
				do: [:ea | s := s , ea , aLetter asString asString].
				l := aLetter asString asLowercase.
			builder html: s.
			builder
				html: (builder getImage: '/schemes/squeak/Letras/' , l , '.gif').
			builder br; br; br.
			query := HVNaughtieWikiIndex beginsWith: aLetter.
			query keysasLowercaseSortedSafely
				do: [:k | 
					v := query at: k.
					builder linkLocal: 'squeak/' , v asString text: k.
					builder br]].
	^ builder! !

!HVNaughtieWiki methodsFor: 'initialize-release' stamp: 'edc 3/4/2011 09:32'!
initialize
super initialize.
	title := 'HVNaughthieWiki'! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/30/2010 17:56'!
jCaptchca
	^ '<a href="/captcha/' , self class index asString , '" title="Captchca" onMouseOver="rollOver(''''captcha'''', true)" onMouseOut="rollOver(''''captcha'''', false)"><img src="/schemes/squeak/Catcha.gif" border=0 width=67 height=28>'! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 5/26/2011 20:01'!
jEditFalse
	^ '<a href="/squeak/' , self class index asString , '" title="View this Page" onMouseOver="rollOver(''''view'''', false)" onMouseOut="rollOver(''''view'''', false)"><img src="/schemes/squeak/viewie.gif" border=0 width=67 height=28 alt="View this Page"><a href="/squeak/' , self class index asString , '.edit" title="Edit this Page" onMouseOver="rollOver(''''edit'''', false)" '! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 2/2/2010 09:16'!
jEditTrue
	^ '<a href="/squeak/' , self class index asString , '" title="View this Page" onMouseOver="rollOver(''''view'''', false)" onMouseOut="rollOver(''''view'''', false)"><img src="/schemes/squeak/viewie.gif" border=0 width=67 height=28 alt="View this Page"><a href="/squeak/' , self class index asString , '.edit" title="Edit this Page" onMouseOver="rollOver(''''edit'''', true)" onMouseOut="rollOver(''''edit'''', false)"><img src="/schemes/squeak/edit.gif" id="edit" name="edit" border=0 width=61 height=28 alt="Edit this Page">'! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 2/14/2011 10:18'!
jIndex
	^ '<a href="/index', '" title="Swiki Index" onMouseOver="rollOver(''''index'''', true)" onMouseOut="rollOver(''''index'''', false)"><img src="/schemes/squeak/index.jpg" border=0 width=32 height=32>'! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 8/12/2010 08:20'!
jSubir
		^ '<script type="text/javascript" src="/schemes/JavaScript/jSubir.js" "></script>'! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 2/2/2010 09:05'!
jselCss
	^ '<a href="/selectCss/' , self class index asString , '" title="Css For this Page" onMouseOver="rollOver(''''selectCss'''', true)" onMouseOut="rollOver(''''selectCss'''', false)"> <img src="/schemes/squeak/selectcoloricon.jpg" border=0 width=67 height=28 alt="Css For this Page">'! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 2/2/2010 07:21'!
link
	| fields i |
	fields := self request postFields.
	i := fields at: 'name'.
	^ self page: i asInteger encript: true! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 8/4/2010 07:06'!
listen
	| p dir builder result basePath |
	builder := self builder.
	p := self nextMethod.
	p
		ifEmpty: [^self play].
basePath := '/media/IOMEGA HDD/Music/', p.
	dir := FileDirectory default directoryNamed: basePath.
	result := OrderedCollection new.
	dir
		withAllSubdirectoriesCollect: [:k | k fileNames
				do: [:fn | result
						add: (k fullNameFor: fn)]].

	result
		do: [:ea | 
			builder linkLocal: 'listen/' , ea value asString text: ea.
			builder br].
	^ builder! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 4/4/2010 10:32'!
next
	| builder |
	builder := self builder.
	builder html:  (self page: HVNaughtieWiki index + 1 encript: false).
	^ self pageEnd: builder! !

!HVNaughtieWiki methodsFor: 'accessing' stamp: 'edc 5/29/2011 07:35'!
page: anInteger encript: mustEncript 
	"Aca intento contruir la pagina"
	| builder aMiHTMLData xhtm s |
	builder := self builder.
	self class index: anInteger.
	aMiHTMLData := self class currentPage.
	self class user = 'visita'
		ifTrue: [self bandera: #view]
		ifFalse: [aMiHTMLData author = self class user
				ifTrue: [self bandera: #edit]
				ifFalse: [self bandera: #view]].
	xhtm := self pageFirstWith: aMiHTMLData.
	self class user = 'visita'
		ifTrue: [self checkVisitorCaptchca
				ifFalse: [s := self doEncript: aMiHTMLData body.
					xhtm := xhtm , s.
					^ builder html: xhtm]].
	xhtm := xhtm , aMiHTMLData body.
	^ builder html: xhtm! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 6/7/2010 08:29'!
pageEnd: builder

	builder html: '<tr><td width=100 rowspan=2><a href="/previous/"><img src="/schemes/squeak/previous.gif" border=0 width=100 height=60 </a> <a href="/next/"><img src="/schemes/squeak/next.gif" border=0 width=100 height=60 </a>  </td><td width="100%" valign=middle>
	</body></html>'.
	^ builder! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 8/11/2010 11:25'!
pageFirstWith: aMiHTMLData 
	| xhtm s |
	xhtm := self htmStart.
	xhtm := xhtm , aMiHTMLData title , '</title>'.
	xhtm := xhtm , self htmScript.
	xhtm := xhtm , self css.
	s := self htmTable: aMiHTMLData color.
	xhtm := xhtm , s.
	
	xhtm := xhtm , aMiHTMLData links.
	xhtm := xhtm , self htmForm1.
	xhtm := xhtm , self htmForm2.
	xhtm := xhtm
				, (self htmDiv: aMiHTMLData).
	^ xhtm! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/17/2010 08:17'!
parseUrl: aString 
	| pos1 pos2 |
	pos1 := (aString indexOf: $=)
				+ 1.
	pos2 := (aString indexOf: $&)
				- 1.
	^self
		search: (aString copyFrom: pos1 to: pos2)! !

!HVNaughtieWiki methodsFor: 'actions' stamp: 'edc 1/27/2010 09:11'!
play
	| file pathName |
	file := urlStream url path.
	pathName := ''.
	file
		from: 3
		to: file size
		do: [:ea | pathName := pathName , '/' , ea].
Transcript show: file last;cr.
	^(StandardFileStream oldFileNamed: pathName)
	
! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 4/4/2010 10:33'!
previous
	| builder |
	builder := self builder.
	builder
		html: (self page: HVNaughtieWiki index - 1 encript: false).
	^ self pageEnd: builder! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 5/26/2011 19:09'!
recent
	| b fecha nC |
	b := self builder.
	b start; h2: 'Recent Changes to Squeak Swiki'.
	nC := SortedCollection
				sortBlock: [:a :z | (a at: 2)
						> (z at: 2)].
	HVNaughtieWiki changes
		keysAndValuesDo: [:k :v | nC
				add: (Array with: k with: v)].
	fecha := (nC first at: 2) date.
	b h3: fecha.
	nC
		do: [:ea | 
			(ea at: 2) date = fecha
				ifFalse: [fecha := (ea at: 2) date.
					b h3: fecha].
			HVNaughtieWiki
				index: (ea at: 1).
			page := HVNaughtieWiki currentPage.
			b html: '<li><a href= ' , 'http://' , self class ip , ':8085/squeak/' , page indexValue asString , '> ' , page title , '</a></li>'].
	b endForm; hr; srcLink; end.
	^ b! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 8/12/2010 10:21'!
remote
	self halt.! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 5/26/2011 07:55'!
save
	"Here we utilize an inherited convenience method to handle uploaded
	files. The block sent to #handleUpload: will be executed for each file
	uploaded. The block needs to take one argument - the filename, and
	should return a stream or nil. If a stream is returned the file
	contents will be written to it and then the stream will be closed.
	Returning nil
	ignores the file."
	| fields aMiHTMLData selector key newFile |
	fields := self request propertyAt: #postFields.
	aMiHTMLData := self security: fields.
	#('title' 'body' 'color' 'links' 'indexValue' 'css' 'ip' )
		do: [:thisField | (fields includesKey: thisField)
				ifTrue: [selector := (thisField , ':') asSymbol.
					aMiHTMLData
						perform: selector
						withArguments: (Array
								with: (fields at: thisField))]].
	aMiHTMLData date: DateAndTime now asTimeStamp.
	HVNaughtieWiki
		addChanges: (Array with: HVNaughtieWiki index with: DateAndTime now asTimeStamp).
	(fields includesKey: 'filestuff')
		ifTrue: [newFile := fields at: 'filestuff'.
			self halt].
	self class pageHistory addFirst: aMiHTMLData.
	key := HVNaughtieWikiIndex default
				keyAtIdentityValue: aMiHTMLData indexValue
				ifAbsent: [].
	key
		ifNotNil: [HVNaughtieWikiIndex default removeKey: key].
	HVNaughtieWikiIndex default at: aMiHTMLData title put: aMiHTMLData indexValue.
	self bandera: #view.
	^ self page: HVNaughtieWiki index encript: false! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 8/11/2010 18:38'!
save: aMiHTMLData 
	self class pageHistory addFirst: aMiHTMLData.
	HVNaughtieWikiIndex default valuesDo:[:v| (v = aMiHTMLData indexValue) ifTrue:[self halt]].
	self bandera: #view.
	^ self redirectToDefault! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/2/2010 15:51'!
schemes
| p filePath dir f| 
p := self urlStream url path.
dir := FileDirectory default.
filePath := dir pathName.
p do: [:ea| filePath := filePath,FileDirectory slash,ea].
f := FileStream oldFileNamed: filePath.
f converter:  Latin1TextConverter new.
^ f contents

! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 3/29/2011 09:12'!
screen
	^self class cssChoser imageForm! !

!HVNaughtieWiki methodsFor: 'accessing' stamp: 'edc 2/6/2010 11:04'!
screenBounds
	^ screenBounds
		ifNil: [screenBounds := Rectangle origin: (0 @ 0) asPoint corner: (1024 @ 768) asPoint]! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 2/6/2010 11:04'!
screenWeb
	^ Form
		fromDisplay: (Rectangle origin: (0 @ 0) asPoint corner: (1024 @ 768) asPoint)! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/17/2010 09:28'!
search
	| url question query builder |
	builder := self builder.
	builder html: self htmSearch.
	url := self urlStream url printString.
	question := url indexOf: $?.
	question = 0
		ifTrue: [builder html: '</body>
</html>']
		ifFalse: [url := url copyFrom: question to: url size.
			query := self parseUrl: url.
			query
				do: [:ea | 
					builder linkLocal: 'squeak/' , ea value asString text: ea key.
					builder br]].
	^ builder! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 8/10/2010 09:15'!
search: pattern 
	| toMatch result |
	(toMatch := pattern copyWithoutAll: {Character space. Character cr. Character tab}) isEmpty
		ifTrue: [^ nil].
	toMatch := (toMatch copyWithout: $.) asLowercase.
	result := OrderedCollection new.
	HVNaughtieWikiIndex default keysAndValuesDo: [:k :v| (k  includesSubstring: toMatch caseSensitive: false) ifTrue:[result add:  (Association key:k value: v)]].
				.
	^ result! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 8/2/2010 10:32'!
searchMusic: aString 
	| dir result builder basePath |
	builder := self builder.
	basePath := '/media/IOMEGA HDD/Music/'.
	dir := FileDirectory default directoryNamed: basePath.
	result := dir entries
				select: [:k | k name includesSubstring: aString caseSensitive: false]
				thenCollect: [:ea | ea name].
	result
		do: [:ea | 
			builder linkLocal: 'listen/' , ea value asString text: ea.
			builder br].
	^ builder! !

!HVNaughtieWiki methodsFor: 'actions' stamp: 'edc 3/24/2011 10:26'!
security: fields 
	| good aMiHTMLData |
	aMiHTMLData := self class currentPage.
	(fields at: 'lock') caseOf: {
		['unlocked'] -> [^ aMiHTMLData].
		['lock'] -> [self halt].
		['locked'] -> 
			[aMiHTMLData
				pass: (fields at: 'password').
			^ aMiHTMLData]}.
	aMiHTMLData isProtected
		ifTrue: [good := aMiHTMLData pass
						= (fields at: 'password')]! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/30/2010 11:11'!
selectCss
	^ '<HTML>
	<HEAD>
	<TITLE>Squeak''s Screen</TITLE>
	</HEAD>
	<BODY>
<div>
<a id="pictureMap" title="Click here" 
href= "/click/">
<img alt="" ismap="ismap" src="/screen/">
</div>
	</BODY>
	</HTML>'! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 4/17/2010 11:25'!
squeak
	| p builder s |
	
	self bandera: #view.
	builder := self builder.
	p := self nextMethod.
	p
		ifNil: [builder
				html: (self page: 1 encript: false)]
		ifNotNil: [(self respondsTo: p asSymbol)
				ifTrue: [^ self perform: p asSymbol]
				ifFalse: [p isPositiveInteger
						ifTrue: [builder
								html: (self page: p asInteger encript: true)]
						ifFalse: [s := self accion: p]]].
	builder html: s.
	^ self pageEnd: builder! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/28/2010 07:41'!
tinymce
| p filePath dir f |
	p := self urlStream url path.
	dir := FileDirectory default.
	filePath := dir pathName.
	p
		do: [:ea | filePath := filePath , FileDirectory slash , ea].
	f := FileStream oldFileNamed: filePath.
	f converter: Latin1TextConverter new.
	^ f contents! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 3/24/2011 10:50'!
title
	^ 'HVCenturyXXIWiki'! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 8/13/2010 09:23'!
trucho
	^ '<h2> <input type="text" name="title" value= "' , HVNaughtieWiki currentPage title , '" size =  60 </h2> '! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 8/12/2010 08:24'!
upload
	"Show the web page for uploading and deleting files."
	"Create a HTML builder object."
	| b checkBoxes fn size deleteButton dir subDirName subDir |
	b := self builder.
	"Start the page, add a heading level 1."
	b start; h1: 'Files'.
	"Start a multipart form with a POST url to the local view instance +
	'/upload'. This will make the POST go the method #upload in this class."
	b postFormMultiPartLocal: 'upload2'.
	"Add an input file field and a submit button with the text 'Upload'.
	In this case we don't care to hold onto the button, the POST goes to
	the #upload method anyways."
	b inputFile; submit: 'Upload'.
	"Add a break making it look better, ending the form and starting a new
	form with no url specified - this makes the POST go to this method by
	default."
	b br; endForm; postForm.
	"Create a table with 3 columns and specify the column labels."
	b
		columnsHeads: #('Choose' 'Filename' 'Size' )
		do: ["Create a dictionary to hold the checkbox widgets for each file
			using the filename as the key."
			checkBoxes := Dictionary new.
			dir := FileDirectory default directoryNamed: 'uploads'.
			subDirName := HVNaughtieWiki index asString.
			(dir directoryExists: subDirName)
				ifFalse: [dir createDirectory: subDirName].
			subDir := dir directoryNamed: subDirName].
	subDir entries
		do: [:e | 
			"For all entries in the directory we pick out filename and size."
			fn := e first.
			size := e last.
			"Add a checkbox to the page and take the resulting widget
			and stuff it into the dictionary using the filename as key."
			checkBoxes at: fn put: b inputCheckbox.
			"#colTab moves to the next column in the table, there we add
			a link for each file that will point to the #file method in
			this class
			with the filename added at the end of the url. #colTab also
			automatically moves to the next row in the table."
			b html: Character tab;
				 linkLocal: 'uploads/' , subDirName , '/' , fn text: fn;
				 html: Character tab;
				 html: size printString;
				 br].
	"Add a delete button with label."
	deleteButton := b submit: 'Delete selected files'.
	"End the form, add a horisontal ruler, a link to the source of this
	method and end the web page."
	b endForm; hr; srcLink; end.
	"Ok, if this was a POST of the second form the deleteButton will know it
	and the code will be run. We loop through all entries in the dictionary
	and depending on the #value of each checkbox we delete the file."
	deleteButton
		ifPressed: [checkBoxes
				keysAndValuesDo: [:name :box | box value
						ifTrue: [subDir deleteFileNamed: name]].
			"We have changed the model (deleted files) so instead of
			returning the page we just built above, because it contains
			rows for files
			that are now deleted - we issue a redirect causing a GET reload
			of this page."
			^ self page: HVNaughtieWiki index encript: false].
	"Return the builder which will cause it to be converted to a HTTP
	response and thus
	have it render the page back to the user. The last thing HV does is to
	send #asHttpResponseTo:
	to the object returned from the page methods, see HVRootView>>process:
	which is the method
	called by Comanche."
	^ b! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 8/12/2010 07:37'!
upload2
	"Upload a file."

	"Here we utilize an inherited convenience method to handle uploaded
	files. The block sent to #handleUpload: will be executed for each file
	uploaded. The block needs to take one argument - the filename, and
	should return a stream or nil. If a stream is returned the file contents
	will be written to it and then the stream will be closed. Returning nil
	ignores the file."
	| dir subDirName subDir aFilename |
	 self handleUpload: [:filename | aFilename := filename.
		"We simple first delete it if it exists and then return a FileStream
		so that the file gets written."
		dir := FileDirectory default directoryNamed: 'uploads'.
		subDirName := HVNaughtieWiki index asString.

		subDir := dir directoryNamed: subDirName.

		(subDir fileExists: filename) ifTrue:[subDir deleteFileNamed: filename].
		subDir newFileNamed: filename].
	self upload3:aFilename.
	^self  page:  HVNaughtieWiki index encript: false! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 8/12/2010 07:38'!
upload3: aFilename
	"Upload a file."

	"Here we utilize an inherited convenience method to handle uploaded
	files. The block sent to #handleUpload: will be executed for each file
	uploaded. The block needs to take one argument - the filename, and
	should return a stream or nil. If a stream is returned the file contents
	will be written to it and then the stream will be closed. Returning nil
	ignores the file."
	| body temp1  pos newLink |

		body := HVNaughtieWiki currentPage body.
		pos := body findString: '</body>'.
		temp1 := body copyFrom: 1 to: pos.
		
		
		newLink :='<a  href="/squeak/uploads/' ,self class index asString ,'/' , aFilename,'">', aFilename,'</a> <br>'.
body := temp1 ,newLink.
HVNaughtieWiki currentPage  date: DateAndTime now asTimeStamp; body: body .
! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 5/25/2011 19:18'!
uploads
	| fileName dir filePath f graphicSuffixes suffix isGraphic |
	fileName := request url.
	fileName := (fileName splitBy: 'squeak') last.
	graphicSuffixes := #('gif' 'bmp' 'jpg' 'jpeg' 'jpe' #, 'form' ).
	suffix := (FileDirectory extensionFor: fileName) asLowercase.
	isGraphic := graphicSuffixes
				anySatisfy: [:each | each match: suffix].
	dir := FileDirectory default.
	filePath := dir pathName.
	filePath := filePath , fileName.
	f := FileStream oldFileNamed: filePath.
	isGraphic
		ifTrue: [^ Form fromBinaryStream: f]
		ifFalse: [f converter: Latin1TextConverter new.
			^ f contents]! !

!HVNaughtieWiki methodsFor: 'urls' stamp: 'edc 1/20/2010 10:14'!
version

| v aMiHTMLData xhtm builder |
builder := self builder.
v := request fields at: 'id'.
aMiHTMLData := HVNaughtieWiki pageHistory at: v asInteger .
xhtm := self pageFirstWith: aMiHTMLData.
xhtm := xhtm, aMiHTMLData body.
^builder html: xhtm! !

HVTransientView subclass: #HVHyperNotePad
	instanceVariableNames: 'screenBounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NaughtieWiki'!

HVHyperNotePad class
	instanceVariableNames: 'screenBounds'!

!HVHyperNotePad commentStamp: 'edc 5/23/2010 11:17' prior: 0!
HVHyperNotePad startDebugOn: 6502!

HVHyperNotePad class
	instanceVariableNames: 'screenBounds'!

!HVHyperNotePad class methodsFor: 'as yet unclassified' stamp: 'edc 5/23/2010 11:16'!
rootView
	^ HVHyperNotePadRoot! !

!HVHyperNotePad methodsFor: 'urls' stamp: 'edc 2/10/2010 09:30'!
click
	| fields aPoint aButton |
	fields := request fields.
	fields ifEmpty: [^self redirectTo: '/'].
	aButton := (fields at: 'button') first.
	aPoint := Point x: (fields at: 'point.x') first asInteger y: (fields at: 'point.y') first asInteger.
	self click: aPoint button: aButton.
	^ self refresh! !

!HVHyperNotePad methodsFor: 'urls' stamp: 'edc 2/6/2010 10:13'!
click: aPoint button: aButton 
	| evt |
	evt := Sensor createMouseEvent.
	aButton = '5'
		ifTrue: [Clipboard clipboardText: textInput.
			World activeHand keyboardFocus editView paste]
		ifFalse: [aButton = '6'
				ifTrue: [evt at: 5 put: 0.
					evt at: 3 put: aPoint x + self screenBounds origin x.
					evt at: 4 put: aPoint y + self screenBounds origin y.
					Sensor processEvent: evt]
				ifFalse: [evt at: 3 put: aPoint x + self screenBounds origin x.
					evt at: 4 put: aPoint y + self screenBounds origin y.
					evt at: 5 put: aButton asNumber.
					Sensor processEvent: evt.
					aButton = '3'
						ifFalse: [evt at: 5 put: 0.
							Sensor processEvent: evt]]].
	(Delay forMilliseconds: 10) wait.
	! !

!HVHyperNotePad methodsFor: 'urls' stamp: 'edc 2/10/2010 09:16'!
default
	| textInput |
	textInput := ''.
	^ '<HTML>
	<HEAD>
	<TITLE>Squeak''s Screen</TITLE>

</head>
<body>
	
<form accept-charset="utf-8" method="post" action="/click">
Button:	
	<br>
	<input type="radio" name="button" value="4" checked>Red
	<input type="radio" name="button" value="1">Yellow
	<input type="radio" name="button" value="2">Blue
	<input type="radio" name="button" value="3">Move
	<input type="radio" name="button" value="6">Position
	<input type="radio" name="button" value="5">Text:
	<input size="30" maxlength="100" type="text" name="textIn" value="' , textInput , '"> 
	<br>
	<input type=image name=point src="/screen">
	<br>
	
	</form>
	</body></html>'! !

!HVHyperNotePad methodsFor: 'urls' stamp: 'edc 2/9/2010 17:54'!
kalseyTabsCss
	"this is from http://kalsey.com/tools/csstabs/ - would also be nice to
	do http://www.alistapart.com/articles/slidingdoors/"
	^ '
.kalsey .navigation-options {
	border-bottom : 1px solid #ccc;
	margin : 0;
	padding-bottom : 19px;
	padding-left : 10px;
}

.kalsey .navigation-options ul, .kalsey .navigation-options li	{
	display : inline;
	list-style-type : none;
	margin : 0;
	padding : 0;
}


.kalsey .navigation-options a:link, .kalsey .navigation-options a:visited	{
	background : #E8EBF0;
	border : 1px solid #ccc;
	color : #666;
	float : left;
	font-size : small;
	font-weight : normal;
	line-height : 14px;
	margin-right : 8px;
	padding : 2px 10px 2px 10px;
	text-decoration : none;
}

.kalsey .navigation-options a:link.active, .kalsey .navigation-options a:visited.active	{
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-options ul a:hover	{
	color : #f00;
}

.kalsey .navigation-options .option-selected a {
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-content {
	background : #fff;
	border : 1px solid #ccc;
	border-top : none;
	clear : both;
	margin : 0px;
	padding : 15px;
	line-height: 1.1;  /* IE6 CSS workaround - http://www.dracos.co.uk/web/css/ie6floatbug/ */
}
'! !

!HVHyperNotePad methodsFor: 'urls' stamp: 'edc 2/10/2010 09:25'!
refresh
	^ '<HTML>
	<HEAD>
	<TITLE>Squeak''s Screen</TITLE>
	</HEAD>
	<meta http-equiv="Refresh" content="1" >
	<BODY>
<form>
Button:	
	<br>
	<input type="radio" name="button" value="4" checked>Red
	<input type="radio" name="button" value="1">Yellow
	<input type="radio" name="button" value="2">Blue
	<input type="radio" name="button" value="3">Move
	<input type="radio" name="button" value="6">Position
	<input type="radio" name="button" value="5">Text:
	<input size="30" maxlength="100" type="text" name="textIn" value="> 
	<br>
	<input type=image name=point src="/screen">
	<br>
	</form>
	</BODY>
	</HTML>'! !

!HVHyperNotePad methodsFor: 'urls' stamp: 'edc 2/6/2010 08:54'!
screen
	^ Form fromDisplay: (Rectangle origin: (0 @ 0) asPoint corner: (1024 @ 768) asPoint).! !

!HVHyperNotePad methodsFor: 'accessing' stamp: 'edc 2/6/2010 10:56'!
screenBounds
	^ screenBounds
		ifNil: [screenBounds := Rectangle origin: (0 @ 0) asPoint corner: (1024 @ 768) asPoint]! !

!HVHyperNotePad methodsFor: 'urls' stamp: 'edc 2/9/2010 17:46'!
toolbarCss
	^ 'body {
	margin-bottom: 25px;
}
#toolbar {
	z-index: 20;
	position: fixed;
	left: 0;
	right: 0;
	bottom: 0;
	padding: 2px;
	color: #444;
	background-color: #eee;
	border-top: 1px solid #aaa;
	font: 10pt Verdana, Arial, Helvetica, sans-serif;
}
#toolbar a {
	color: #444;
	padding-left: 3px;
	padding-right: 3px;
	text-decoration: none;
}
#toolbar a:hover {
	color: #111;
}
#toolbar a.deprecated {
	color: #ff7000;
}'! !

!HVHyperNotePad methodsFor: 'urls' stamp: 'edc 2/9/2010 17:54'!
windowCss
	^ '.window {
	border: 1px solid #aaa;
}
.window .window-titlebar {
	color: #444;
	padding: 5px;
	overflow: hidden;
	background-color: #eee;
	border-bottom: 1px solid #aaa;
	font: 10pt Verdana, Arial, Helvetica, sans-serif;
}
.window .window-titlebar .window-title {
	float: left;
	font-weight: bold;
	padding-left: 20px;
}
.window .window-titlebar .browserhaloplugin {
	background: url(codebrowser.png) no-repeat;
}
.window .window-titlebar .inspectorplugin {
	background: url(inspector.png) no-repeat;
}
.window .window-titlebar .styleshaloplugin {
	background: url(styleeditor.png) no-repeat;
}
.window .window-titlebar .configuretoolplugin {
	background: url(config.png) no-repeat;
}
.window .window-titlebar .profilertoolplugin {
	background: url(profiler.png) no-repeat;
}
.window .window-titlebar .memorytoolplugin {
	background: url(memory.png) no-repeat;
}
.window .window-titlebar .window-close {
	float: right;
}
.window .window-titlebar .window-close a {
	color: #444;
	text-decoration: none;
}
.window .window-titlebar .window-close a:hover {
	color: #111;
}
.window .window-content {
	clear: both;
	padding: 2px;
}'! !

HVTransientView subclass: #HVPageHeadingDemo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NaughtieWiki'!

HVPageHeadingDemo class
	instanceVariableNames: 'morph'!

!HVPageHeadingDemo commentStamp: 'edc 4/5/2010 19:10' prior: 0!
HVPageHeadingDemo cleanMorph

HVPageHeadingDemo  stop

HVPageHeadingDemo startDebugOn: 8080!

HVPageHeadingDemo class
	instanceVariableNames: 'morph'!

!HVPageHeadingDemo class methodsFor: 'private' stamp: 'edc 4/5/2010 19:10'!
cleanMorph
morph := nil! !

!HVPageHeadingDemo class methodsFor: 'accessing' stamp: 'edc 4/5/2010 15:52'!
morph
^morph! !

!HVPageHeadingDemo class methodsFor: 'accessing' stamp: 'edc 4/5/2010 18:51'!
morph: aMorph 
" Esto crea todos los metodos que llaman los botones del AligmentMorph"
	morph := aMorph.
	aMorph submorphsDo:[:sb | self compile: ( sb actionSelector)classified: 'urls' notifying: nil]! !

!HVPageHeadingDemo methodsFor: 'urls' stamp: 'edc 4/5/2010 19:40'!
click
	| punto m aPoint selMorph |
	punto := request fields keyAtValue: ''.
	punto := punto findTokens: ','.
	aPoint := Point x: punto first y: punto last.
	m := self class morph.
	m openInWorld.
	selMorph := m morphsAt: m topLeft + aPoint.
	selMorph := selMorph
				detect: [:ea | ea isKindOf: SimpleButtonMorph].
	^self perform: selMorph actionSelector! !

!HVPageHeadingDemo methodsFor: 'urls' stamp: 'edc 4/5/2010 19:40'!
cronicas
	^  '<style type="text/css">body {
	background-color:#a5a5a5}

body, td, th, h1, h2, h3 {
	color:#595959}</style>
	<body> <h1> ''''Cronicas'''' </h1> </ body>'! !

!HVPageHeadingDemo methodsFor: 'urls' stamp: 'edc 4/5/2010 16:16'!
default

	
^ '<HTML>
	<HEAD>
	<TITLE>Squeak''s Screen</TITLE>
	</HEAD>
	<BODY>
<div>
<a id="pictureMap" title="Click here" 
href= "/click/">
<img alt="" ismap="ismap" src="/pageheading/">
</div>
	</BODY>
	</HTML>'! !

!HVPageHeadingDemo methodsFor: 'urls' stamp: 'edc 4/5/2010 19:43'!
divagacionesmorplenauticas
	^  '<style type="text/css">body {
	background-color:#b7eaff}

body, td, th, h1, h2, h3 {
	color:#471400}</style>
	<body><h1> ''''Divagaciones morplenauticas'''' </h1> </ body>'! !

!HVPageHeadingDemo methodsFor: 'urls' stamp: 'edc 4/5/2010 19:52'!
documentacion
	^ '<style type="text/css">body {
	background-color:#ccffcc}

body, td, th, h1, h2, h3 {
	color:#003359}</style>
	<body><h1> ''''Documentacion'''' </h1>
	<h2> ''''Documentacion'''' </h2>
	<h3> ''''Documentacion'''' </h3>
	 </ body>'! !

!HVPageHeadingDemo methodsFor: 'urls' stamp: 'edc 4/5/2010 19:24'!
enlaces! !

!HVPageHeadingDemo methodsFor: 'urls' stamp: 'edc 4/5/2010 19:45'!
integrantes
	^ '<style type="text/css">body {
	background-color:#ffcba5}

body, td, th, h1, h2, h3 {
	color:#003359}</style>
	<body><h1> ''''Integrantes'''' </h1> </ body>'! !

!HVPageHeadingDemo methodsFor: 'urls' stamp: 'edc 4/5/2010 15:59'!
pageheading
^self class morph! !

HVRootView subclass: #HVHyperNotePadRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NaughtieWiki'!

!HVHyperNotePadRoot methodsFor: 'start-stop' stamp: 'edc 5/23/2010 11:26'!
startOn: portNum mode: mode 
	"Creates a new standalone http service with this root view 
	plugged in."
	| name ma |
	Transcript clear.
	name := viewClass
				ifNil: [self class name]
				ifNotNil: [viewClass name].
	ma := ModuleAssembly core.
	coreMod := ma currentModule.
	alias = ''
		ifTrue: [ma
				addPlug: [:request | self process: request]]
		ifFalse: [ma
				alias: alias
				to: [ma
						addPlug: [:request | 
							request keepAlive: true.
							self process: request]]].
	^ (HttpService startOn: portNum named: name) plug: ma rootModule;
		 mode: mode;
		 keepAlive: true! !

HVRootView subclass: #HVNaughtieWikiRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NaughtieWiki'!

!HVNaughtieWikiRoot methodsFor: 'start-stop' stamp: 'edc 4/3/2010 07:58'!
startOn: portNum mode: mode 
	"Creates a new standalone http service with this root view 
	plugged in."
	| name ma authdb |
	Transcript clear.
	name := viewClass
				ifNil: [self class name]
				ifNotNil: [viewClass name].
	ma := ModuleAssembly core.
	coreMod := ma currentModule.
	ma
		logTo: (KomLogger
				on: (FileStream oldFileNamed: 'server.log')).
	ma
		alias: '/squeak'
		to: [ma
				logTo: (KomLogger on: Transcript)].
	ma
		alias: '/busca'
		to: [ma
				logTo: (KomLogger on: Transcript)].
	authdb := HVNaughtieUsers new.
	
	ma authenticate: authdb realm: 'HVNaughtie'.
	ma trackSessions.
	sessionMod := ma currentModule.
	ma sessionTimeout: 1.
	alias = ''
		ifTrue: [ma
				addPlug: [:request | self process: request]]
		ifFalse: [ma
				alias: alias
				to: [ma
						addPlug: [:request | self process: request]]].
	^ (HttpService startOn: portNum named: name) plug: ma rootModule;
		 mode: mode! !

Dictionary subclass: #HVNaughtieWikiIndex
	instanceVariableNames: ''
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'NaughtieWiki'!

!HVNaughtieWikiIndex commentStamp: 'edc 8/10/2010 10:12' prior: 0!
HVNaughtieWikiIndex default inspect!

!HVNaughtieWikiIndex class methodsFor: 'instance variables' stamp: 'edc 2/15/2011 07:16'!
beginsWith: aLetter 
	"HVNaughtieWikiIndex beginsWith: 'A'"
	| nD |
	nD := super new.
	Default
		associationsDo: [:mAssoc | (mAssoc key beginsWith: aLetter asString)
				ifTrue: [nD add: mAssoc]].
	^ nD ! !

!HVNaughtieWikiIndex class methodsFor: 'instance variables' stamp: 'edc 8/10/2010 07:47'!
create
	"HVNaughtieWikiIndex create"
	| nD |
	Default
		ifNil: [nD := self new.
			HVNaughtieWiki swiki
				keysAndValuesDo: [:k :v | nD at: v last title put: k]].
	Default := nD.
	^ Default! !

!HVNaughtieWikiIndex class methodsFor: 'instance variables' stamp: 'edc 8/10/2010 10:14'!
default
	^ Default ! !

!HVNaughtieWikiIndex class methodsFor: 'instance variables' stamp: 'edc 8/10/2010 07:49'!
reset
	"HVNaughtieWikiIndex reset"
	
	Default := nil.
! !

Object subclass: #CreateCssFromMe
	instanceVariableNames: ''
	classVariableNames: 'ColoresDIC Ima MisCss'
	poolDictionaries: ''
	category: 'NaughtieWiki'!

CreateCssFromMe class
	instanceVariableNames: 'last'!

!CreateCssFromMe commentStamp: 'edc 1/19/2010 05:16' prior: 0!
CreateCssFromMe current

CreateCssFromMe last: 'Maize'!

CreateCssFromMe class
	instanceVariableNames: 'last'!

!CreateCssFromMe class methodsFor: 'as yet unclassified' stamp: 'edc 1/28/2010 07:03'!
background: bk body: t 
	^ 'body {
	background-color:' , bk , '}

body, td, th, h1, h2, h3 {
	color:' , t , '}
	'! !

!CreateCssFromMe class methodsFor: 'as yet unclassified' stamp: 'edc 1/19/2010 06:31'!
create: aMorph 
	| bk s t |
	bk := aMorph color asHTMLColor.
	s := aMorph submorphs first.
	t := s color asHTMLColor.
	last := s contents.
	s := self background: bk body: t.
	^ Array with: last with: '<style type="text/css">' , s , '</style>
	<body>'! !

!CreateCssFromMe class methodsFor: 'as yet unclassified' stamp: 'edc 1/19/2010 07:26'!
createMisCss: aMorph 
	| nD bk s t |
	nD := Dictionary new.
	aMorph
		submorphsDo: [:sm | 
			bk := sm color asHTMLColor.
			s := sm submorphs first.
			t := s color asHTMLColor.
			nD
				at: s contents
				put: (
	'<style type="text/css">' , (self background: bk body: t) , '</style>
	<body>')].
	MisCss := nD! !

!CreateCssFromMe class methodsFor: 'as yet unclassified' stamp: 'edc 1/19/2010 05:40'!
current
	| s |
	s := self misCss at: last.
	^ '<br><style type="text/css">' , s , '</style><br><body>'! !

!CreateCssFromMe class methodsFor: 'as yet unclassified' stamp: 'edc 1/18/2010 10:41'!
getImageForm
^ Ima! !

!CreateCssFromMe class methodsFor: 'accessing' stamp: 'edc 1/19/2010 05:10'!
last
	"Answer the value of last"

	^ last! !

!CreateCssFromMe class methodsFor: 'accessing' stamp: 'edc 1/19/2010 05:10'!
last: anObject
	"Set the value of last"

	last := anObject! !

!CreateCssFromMe class methodsFor: 'as yet unclassified' stamp: 'edc 1/18/2010 09:39'!
misCss
^MisCss! !

!CreateCssFromMe class methodsFor: 'as yet unclassified' stamp: 'edc  1/22/2010 07:51'!
misCss: aDict
MisCss := aDict! !

!CreateCssFromMe class methodsFor: 'as yet unclassified' stamp: 'edc 5/30/2010 12:53'!
readColoresDICFromFile
	"CreateCssFromMe readColoresDICFromFile"
	| file linea valores rgb colorName |
	ColoresDIC := Dictionary new.
	file := FileStream oldFileNamed: 'ColoresDIC.txt'.
	[file atEnd]
		whileFalse: [linea := file nextLine.
			valores := linea findTokens: Character space.
			colorName := valores first.
			valores remove: valores first.
			rgb := valores
						collect: [:each | ((each asInteger )/ 100) asFloat].
			ColoresDIC
				at: colorName
				put: (Color fromArray: rgb)].
	ColoresDIC inspect! !

!CreateCssFromMe class methodsFor: 'as yet unclassified' stamp: 'edc 4/5/2010 19:34'!
selectCss: aString
	 ^MisCss at: aString ifAbsent:[Error do:'This color do not exist']! !

!CreateCssFromMe class methodsFor: 'as yet unclassified' stamp: 'edc 1/18/2010 10:41'!
setImageForm: form
 Ima := form! !

Object subclass: #HVPageHeading
	instanceVariableNames: 'buttonList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NaughtieWiki'!

!HVPageHeading methodsFor: 'action' stamp: 'edc 4/5/2010 19:22'!
backColor: aColor 
	| row b |
	row := PasteUpMorph new behaveLikeHolder openInWorld.
	row color: Color white.
	buttonList
		do: [:each | 
			b := SimpleButtonMorph new label: each;
						 color: aColor;
						 target: self;
						 actionSelector: each asLowercase asSymbol.
			row addMorphBack: b].
	row openInHand! !

!HVPageHeading methodsFor: 'accessing' stamp: 'edc 4/5/2010 07:05'!
buttonList
	"Answer the value of buttonList"

	^ buttonList! !

!HVPageHeading methodsFor: 'accessing' stamp: 'edc 4/5/2010 07:05'!
buttonList: anObject
	"Set the value of buttonList"

	buttonList := anObject! !

!HVPageHeading methodsFor: 'action' stamp: 'edc 4/5/2010 08:58'!
chooseButtonColor
	| coloresCrayon  buttons b max maxX x y cuenta paleta done|
	coloresCrayon :=HVcaptchca colores.
done := false.
	
	buttons := OrderedCollection new.
	paleta := PasteUpMorph new.
	paleta layoutPolicy: nil.
	paleta hResizing: #rigid.
	paleta vResizing: #rigid.
	paleta borderWidth: 2.
	paleta borderColor: Color black.
	paleta color: Color white.
	maxX := 0.
	x := 0.
	y := 0.
	cuenta := 0.
	coloresCrayon
		keysAndValuesDo: [:name :rgb | 
			b := SimpleButtonMorph new label: name;
						 color: rgb;
						 target: self;
						 actionSelector: #backColor:;
						
						arguments: (Array with: rgb).
			buttons add: b].
	b := SimpleButtonMorph new label: 'Enough Fun ?';
				 color: Color white;
				 target: self;
				 actionSelector: #killFrontDialog.
	buttons add: b.
	"Compute the max width"
	max := 0.
	buttons
		do: [:each | max := each width max: max].
	"Set all widths to the max value"
	buttons
		do: [:each | each width: max].
	buttons
		reverseDo: [:each | 
			each position: x @ y.
			paleta addMorph: each.
			cuenta < 7
				ifTrue: [x := x + each width.
					cuenta := cuenta + 1]
				ifFalse: [y := y + each height.
					x > maxX
						ifTrue: [maxX := x].
					x := 0.
					cuenta := 0]].
	maxX := maxX + 10.
	y := y + 10.
	paleta extent: maxX @ y.
	paleta position: 30 @ 30.
	paleta becomeLikeAHolder.
	paleta openInWorld.
	[done]
		whileFalse: [World doOneCycle]! !

!HVPageHeading methodsFor: 'initialize-release' stamp: 'edc 4/5/2010 07:15'!
initialize
	| buttonName |
	buttonList := OrderedCollection new.
	[buttonName := FillInTheBlankMorph request: 'give a name for this button' initialAnswer: 'none'.
	buttonList add: buttonName.
	buttonName = 'none'] whileFalse.! !

Object subclass: #HVcaptchca
	instanceVariableNames: ''
	classVariableNames: 'Colores'
	poolDictionaries: ''
	category: 'NaughtieWiki'!

HVcaptchca class
	instanceVariableNames: 'last'!

!HVcaptchca commentStamp: 'edc 4/3/2010 08:55' prior: 0!
HVcaptchca last
!

HVcaptchca class
	instanceVariableNames: 'last'!

!HVcaptchca class methodsFor: 'accessing' stamp: 'edc 9/28/2009 17:34'!
colores
^Colores! !

!HVcaptchca class methodsFor: 'accessing' stamp: 'edc 9/28/2009 17:34'!
colores: aDictionary
Colores:= aDictionary! !

!HVcaptchca class methodsFor: 'instance creation' stamp: 'edc 8/16/2010 11:09'!
encript
" HVcaptchca encript "
	| unordered encript s |
	unordered := (($A to: $Z) shuffled , ($a to: $z) shuffled , ($0 to: $9) shuffled) shuffled.
	encript := String new.
	1
		to: 9
		do: [:i | 
			s := (unordered at: i) asString.
			encript := encript , s]! !

!HVcaptchca class methodsFor: 'accessing' stamp: 'edc 4/3/2010 08:30'!
last
^last! !

!HVcaptchca class methodsFor: 'accessing' stamp: 'edc 4/3/2010 08:30'!
last: aString
	 last := aString! !

!HVcaptchca class methodsFor: 'instance creation' stamp: 'edc 6/2/2010 08:14'!
oneDifferentIn5

| scheduler |
TaskScheduler stopAll.
scheduler := TaskScheduler new.
scheduler start.

"Let's save the image every hour"
scheduler
do: [self new]
every: 5 minutes.
^self new! !

!HVcaptchca methodsFor: 'initialize-release' stamp: 'edc 5/25/2011 17:46'!
initialize
	| unordered s cartel p y fondo encript nC lC n |
	fondo := BorderedMorph new extent: 280 @ 120;
				 borderWidth: 2;
				 toggleStickiness;
				 openInWorld.
	nC := ($A to: $Z) shuffled copyFrom: 1 to: 3.
	lC := ($a to: $z) shuffled copyFrom: 1 to: 3.
	n := ($0 to: $9) shuffled copyFrom: 1 to: 3.
	unordered := (nC , lC , n) shuffled.
	Transcript show: 	unordered;cr. 
	encript := String new.
	p := 0 @ 30.
	1
		to: 9
		do: [:i | 
			s := (unordered at: i) asString.
			encript := encript , s.
			cartel := StringMorph
						contents: s
						font: ((TextStyle named: #ComicSansMS)
								fontOfSize: 48).
			cartel position: p;
				 color: self class colores atRandom.
			y := 30 atRandom.
			i odd
				ifTrue: [y := y negated].
			p := p + (30 @ y) asPoint.
			fondo addMorphBack: cartel].
	fondo addAlarm: #delete after: 5000.
	self class last: encript.
	^ Array with: fondo imageForm with: encript! !

Object subclass: #MP3DataBase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NaughtieWiki'!

MP3DataBase class
	instanceVariableNames: 'musicFiles'!

!MP3DataBase commentStamp: 'edc 3/17/2010 08:02' prior: 0!
MP3DataBase start!

MP3DataBase class
	instanceVariableNames: 'musicFiles'!

!MP3DataBase class methodsFor: 'as yet unclassified' stamp: 'edc 3/19/2010 09:40'!
id3v3
	| id3 |
	id3 := Dictionary new.
	id3 at: 'TALB' put: String new.
	id3 at: 'TCOM' put: String new.
	id3 at: 'TDAT' put: String new.
	id3 at: 'TIT1' put: String new.
	id3 at: 'TIT2' put: String new.
	id3 at: 'TIT3' put: String new.
	id3 at: 'TOAL' put: String new.
	
	id3 at: 'TRCK' put: String new.id3 at: 'TYER' put: String new.
	
	^ id3! !

!MP3DataBase class methodsFor: 'as yet unclassified' stamp: 'edc 3/17/2010 09:41'!
nexTag: aFile 
	| tag fsize unknow |
	
	tag := aFile next: 3.
fsize := (aFile next: 3) asHex.
			fsize := Number readFrom: fsize base: 16.
			unknow := aFile next: fsize.
			^ Array with: tag with: unknow! !

!MP3DataBase class methodsFor: 'as yet unclassified' stamp: 'edc 3/19/2010 10:03'!
nexTagV3: aFile 
	| tag fsize unknow flags |
	tag := aFile next: 4.
	fsize := (aFile next: 4) asHex.
	flags := aFile next: 2.
	fsize := Number readFrom: fsize base: 16.
	unknow := aFile next: fsize.
	(#('TENC' 'WXXX' 'TCOP' 'TOPE' 'TCOM' 'TIT2' 'TPE1' 'COMM' 'TCON' 'TYER' 'TRCK' 'TSSE' 'TALB' 'COMM' 'TALB' 'TLEN' 'MCDI' ) includes: tag)
		ifTrue: [^ Array with: tag with: unknow]
		ifFalse: [
			^ false]! !

!MP3DataBase class methodsFor: 'as yet unclassified' stamp: 'edc 3/19/2010 10:37'!
start
	"MP3DataBase start"
	| dir aFileList remaining dirs path |
	musicFiles := Dictionary new.
	dir := FileList2 modalFolderSelector.
	aFileList := SortedCollection new.
	remaining := OrderedCollection new.
	dirs := OrderedCollection new.
	remaining addLast: dir.
	[remaining isEmpty]
		whileFalse: [dir := remaining removeFirst.
			dirs add: dir.
			dir entries
				do: [:ent | ent isDirectory
						ifTrue: [remaining
								addLast: (dir directoryNamed: ent name).
							]
						ifFalse: [('*mp3' match: ent name asLowercase)
								ifTrue: [path := dir pathName , FileDirectory dot , ent name.
									musicFiles
										at: path
										put: (self
												unTag: (dir oldFileNamed: ent name))]]]].
	self halt! !

!MP3DataBase class methodsFor: 'as yet unclassified' stamp: 'edc 3/19/2010 09:05'!
unTag: aFile 
	"aFile setConverterForCode."
	| versionM |
	aFile setConverterForCode.
	aFile next: 3.
	versionM := aFile next.
	aFile next.
	versionM value asInteger = 2
		ifTrue: [^ self version2: aFile].
	versionM value asInteger = 3
		ifTrue: [^ self version3: aFile]! !

!MP3DataBase class methodsFor: 'as yet unclassified' stamp: 'edc 3/19/2010 10:36'!
version2: aFile 
	| size flags id3 r |
	id3 := Dictionary new.
	flags := aFile next.
	size := aFile next: 4.
	size := size asHex.
	size := Number readFrom: size base: 16.
	[aFile position < size]
		whileTrue: [r := self nexTag: aFile.
			Transcript show: r;
				 cr.
			id3 at: r first put: r last].
	^ id3! !

!MP3DataBase class methodsFor: 'as yet unclassified' stamp: 'edc 3/19/2010 10:43'!
version2ags
	'BUF Recommended buffer size
CNT Play counter
COM Comments
CRA Audio encryption
  CRM Encrypted meta frame
  ETC Event timing codes
 EQU Equalization
 GEO General encapsulated object
IPL Involved people list
  MCI Music CD Identifier
 MLL MPEG location lookup table
 PIC Attached picture
 POP Popularimeter
REV Reverb
 RVA Relative volume adjustment
  SLT Synchronized lyric/text
  STC Synced tempo codes
TAL Album/Movie/Show title
   TBP BPM (Beats Per Minute)
   TCM Composer
   TCO Content type
   TCR Copyright message
   TDA Date
   TDY Playlist delay
   TEN Encoded by
   TFT File type
   TIM Time
   TKE Initial key
   TLA Language(s)
   TLE Length
   TMT Media type
   TOA Original artist(s)/performer(s)
   TOF Original filename
   TOL Original Lyricist(s)/text writer(s)
   TOR Original release year
   TOT Original album/Movie/Show title
   TP1 Lead artist(s)/Lead performer(s)/Soloist(s)/Performing group
   TP2 Band/Orchestra/Accompaniment
   TP3 Conductor/Performer refinement
   TP4 Interpreted, remixed, or otherwise modified by
   TPA Part of a set
   TPB Publisher
   TRC ISRC (International Standard Recording Code)
   TRD Recording dates
   TRK Track number/Position in set
   TSI Size
   TSS Software/hardware and settings used for encoding
   TT1 Content group description
   TT2 Title/Songname/Content description
   TT3 Subtitle/Description refinement
   TXT Lyricist/text writer
TXX User defined text information frame
   TYE Year
 UFI Unique file identifier
ULT Unsychronized lyric/text transcription
 WAF Official audio file webpage
   WAR Official artist/performer webpage
   WAS Official audio source webpage
   WCM Commercial information
   WCP Copyright/Legal information
   WPB Publishers official webpage
WXX User defined URL link frame


'! !

!MP3DataBase class methodsFor: 'as yet unclassified' stamp: 'edc 3/19/2010 09:58'!
version3: aFile 
	| size flags id3 r val |
	id3 := self id3v3.
	flags := aFile next.
	size := (aFile next: 4) asHex.
	size := Number readFrom: size base: 16.
	[aFile position < size]
		whileTrue: [r := self nexTagV3: aFile.
			Transcript show: r;
				 cr.
				r = false ifTrue:[size := aFile position]
				ifFalse:[
			val := id3
						at: r first
						ifAbsent: [].
			val
				ifNotNil: [id3 at: r first put: r last]]].
	^ id3! !

!MP3DataBase class methodsFor: 'as yet unclassified' stamp: 'edc 3/19/2010 09:30'!
version3Tags
' TALB Album/Movie/Show title
 TBPM BPM (beats per minute)
 TCOM Composer
 TCON Content type
 TCOP Copyright message
 TDAT Date (replaced by TDRC in v2.4)
 TDLY Playlist delay
 TENC Encoded by
 TEXT Lyricist/Text writer
 TFLT File type
 TIME Time (replaced by TDRC in v2.4)
 TIT1 Content group description
 TIT2 Title/songname/content description
 TIT3 Subtitle/Description refinement
 TKEY Initial key
 TLAN Language(s)
 TLEN Length
 TMED Media type
 TOAL Original album/movie/show title
 TOFN Original filename
 TOLY Original lyricist(s)/text writer(s)
 TOPE Original artist(s)/performer(s)
 TORY Original release year (replaced by TDOR in v2.4)
 TOWN File owner/licensee
 TPE1 Lead performer(s)/Soloist(s)
 TPE2 Band/orchestra/accompaniment
 TPE3 Conductor/performer refinement
 TPE4 Interpreted, remixed, or otherwise modified by
 TPOS Part of a set
 TPUB Publisher
 TRCK Track number/Position in set
 TRDA Recording dates (replaced by TDRC in v2.4)
 TRSN Internet radio station name
 TRSO Internet radio station owner
 TSIZ Size (deprecated in v2.4)
 TSRC ISRC (international standard recording code)
 TSSE Software/Hardware and settings used for encoding
 TYER Year (replaced by TDRC in v2.4)
 TXXX User defined text information frame
'! !

Object subclass: #MiHTMLData
	instanceVariableNames: 'title body date color links indexValue css ip pass author'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NaughtieWiki'!

MiHTMLData class
	instanceVariableNames: 'current'!

MiHTMLData class
	instanceVariableNames: 'current'!

!MiHTMLData class methodsFor: 'as yet unclassified' stamp: 'edc 5/6/2011 08:56'!
bodyDefault
self halt.! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 5/26/2011 07:23'!
author
	"Answer the value of author"

	^ author! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 5/26/2011 07:23'!
author: anObject
	"Set the value of author"

	author := anObject! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 1/4/2010 16:44'!
body
	"Answer the value of body"

	^ body! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 5/6/2011 09:41'!
body: aString 
	"Set the value of body"
	
	body := self shouldCreateaPage: aString! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 1/12/2010 09:47'!
color
	"Answer the value of color"

	^ color! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 1/12/2010 09:47'!
color: anObject
	"Set the value of color"

	color := anObject! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc  1/22/2010 07:52'!
css
	"Answer the value of css"

	^ css ifNil: ['Default' ]! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 1/19/2010 06:26'!
css: anObject
	"Set the value of css"

	css := anObject! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 1/4/2010 16:44'!
date
	"Answer the value of date"

	^ date! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 1/4/2010 16:44'!
date: anObject
	"Set the value of date"

	date := anObject! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 1/17/2010 08:33'!
indexValue
	"Answer the value of indexValue"

	^ indexValue! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 1/17/2010 08:33'!
indexValue: anObject
	"Set the value of indexValue"

	indexValue := anObject! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 1/19/2010 11:00'!
ip
	"Answer the value of ip"

	^ ip ifNil:['localhost']! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 1/19/2010 10:59'!
ip: anObject
	"Set the value of ip"

	ip := anObject! !

!MiHTMLData methodsFor: 'testing' stamp: 'edc 3/10/2011 09:32'!
isNewPage
^ self body isNil! !

!MiHTMLData methodsFor: 'testing' stamp: 'edc 8/16/2010 08:35'!
isProtected
	^ (self pass = '') not! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 8/11/2010 10:31'!
links
	^ links
		ifNil: ['</form>']! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 1/12/2010 09:47'!
links: anObject
	"Set the value of links"

	links := anObject! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 8/16/2010 08:29'!
pass
	"Answer the value of pass"
	^ pass
		ifNil: [pass := '']! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 8/13/2010 10:52'!
pass: anObject
	"Set the value of pass"

	pass := anObject! !

!MiHTMLData methodsFor: 'formatting' stamp: 'edc 5/28/2011 08:21'!
shouldCreateaPage: stream 
	| link pos1 pos2 htmLink shouldCreate|
	pos1 := stream indexOfSubCollection: '[['.
	pos1 = 0
		ifTrue: [^ stream].
	pos1 < stream size
		ifTrue: [pos2 := stream
						indexOfSubCollection: ']]'
						startingAt: pos1
						ifAbsent: [0].
			link := stream copyFrom: pos1 + 2 to: pos2 - 1.
			shouldCreate := (link
					detect: [:each | each isAlphaNumericOrSpace not]
					ifNone: []).
					shouldCreate isNil
				ifTrue: [HVNaughtieWiki
						newPageIndex: HVNaughtieWiki lastPage
						named: link
						linkFrom: self indexValue.
					htmLink := '<a class="internal" href="/squeak/' , HVNaughtieWiki lastPage asString , '">' , link , '</a>'.
					^ (stream copyFrom: 1 to: pos1 - 1)
						, htmLink
						, (stream copyFrom: pos2 + 2 to: stream size)]
				ifFalse: [^ stream]]! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 1/4/2010 16:44'!
title
	"Answer the value of title"

	^ title! !

!MiHTMLData methodsFor: 'accessing' stamp: 'edc 1/4/2010 16:44'!
title: anObject
	"Set the value of title"

	title := anObject! !

KomAuthDb subclass: #HVNaughtieUsers
	instanceVariableNames: ''
	classVariableNames: 'DataBase Logs'
	poolDictionaries: ''
	category: 'NaughtieWiki'!

HVNaughtieUsers class
	instanceVariableNames: 'visitors'!

!HVNaughtieUsers commentStamp: 'edc 6/1/2010 11:18' prior: 0!
HVNaughtieUsers visitors

!

HVNaughtieUsers class
	instanceVariableNames: 'visitors'!

!HVNaughtieUsers class methodsFor: 'as yet unclassified' stamp: 'edc 2/15/2010 18:18'!
addUser: user mail: mail
self halt.! !

!HVNaughtieUsers class methodsFor: 'as yet unclassified' stamp: 'edc 2/15/2010 18:06'!
getDataBase
" HVNaughtieUsers getDataBase  "
	^ DataBase! !

!HVNaughtieUsers class methodsFor: 'as yet unclassified' stamp: 'edc 5/19/2010 16:13'!
nosabemos: request 
	| remoteIp |
	remoteIp := request remoteAddress asIpString.
	HVNaughtieUsers visitors
		at: (request propertyAt: #host)
		ifAbsentPut: [OrderedCollection new]! !

!HVNaughtieUsers class methodsFor: 'as yet unclassified' stamp: 'edc 6/5/2010 07:53'!
search
" HVNaughtieUsers search "
|nD search |
search := FillInTheBlank request: 'Nombre?'.
search :='*', search ,'*'.
nD := Dictionary new.
DataBase keysDo: [:k| (search match: k ) ifTrue:[nD at: k put: (DataBase at: k) ]].
nD inspect! !

!HVNaughtieUsers class methodsFor: 'as yet unclassified' stamp: 'edc 2/15/2010 17:57'!
setDataBase: anObject
DataBase := anObject! !

!HVNaughtieUsers class methodsFor: 'as yet unclassified' stamp: 'edc 1/20/2007 08:01'!
visitors
	"Answer the value of visitors"
	^ visitors! !

!HVNaughtieUsers class methodsFor: 'as yet unclassified' stamp: 'edc 1/20/2007 08:01'!
visitors: anObject 
	"Set the value of visitors"
	visitors := anObject! !

!HVNaughtieUsers methodsFor: 'as yet unclassified' stamp: 'edc 2/15/2010 18:19'!
encode: password 
^ password! !

!HVNaughtieUsers methodsFor: 'as yet unclassified' stamp: 'edc 8/11/2010 10:13'!
verifyPassword: aPassword forUser: userName 
	| log valid |
	
	log := userName = 'visita'.
	log
		ifTrue: [valid := true]
		ifFalse: [log := self class getDataBase
						at: userName
						ifAbsent: [^ false].
			(valid := log = aPassword)
				ifFalse: [valid := log last = aPassword]].
	HVNaughtieWiki user: userName.
	^ valid! !
